proc adevice {Width Height} {
  global adevice devNum
    set devNum [expr $devNum + 1]
  set dev .dev$devNum
  toplevel $dev
  wm title $dev "Device $devNum"
 
  if { ($Width==0) && ($Height==0)} {
    set Width 600
    set Height 600
  } else {
    set Width [expr $Width*100]
    set Height [expr $Height*100]
  }

  pgwindow $dev.p$devNum -width $Width -height $Height
  pack $dev.p$devNum
  set temp device$devNum
  set output [smalltalk "|tmp dev|
 	     Smalltalk at:#Udevice$devNum put: nil!
	     Udevice$devNum _ (Device new: 'tk').
    	     gXUUgraphics at: #gXcurrentdevice put: (Udevice$devNum Open).
        ((gXUUgraphics at: #gXcurrentgraphics) addToDeviceList: Udevice$devNum).
             gXUUstatus _ 1.
             gXUUgraphics at: #gXcurrentpicture put: nil.
             gXUUgraphics at: #gXcurrentwindow put: nil!"]

  testOutput $output

  tixButtonBox $dev.box -orientation horizontal
  $dev.box add alter -text Alter  	              	-command alter
  $dev.box add cursor -text Cursor       	       	-command cursor
  $dev.box add hardcopy -text Hardcopy         		-command hardcopy
  $dev.box add mulitplot -text Multiplot                -command mulitplot
  $dev.box add plot -text Plot          		-command plot
  $dev.box add zoom -text Zoom          		-command zoom
  $dev.box add clear -text Clear               		-command deviceClear
  $dev.box add close -text Close               	-command "deviceClose {$dev}"

  menubutton $dev.annotate -text Primitives -menu $dev.annotate.menu
  set m [menu $dev.annotate.menu]

  $m add command -label "Picture"                 -command picture

  $m add cascade -label Window -menu $m.window
  set m2 [menu $m.window]
  $m2 add command -label Unscaled                 -command winUnscaled
  $m2 add command -label "Unscaled..."            -command unscaledOptions
  $m2 add command -label "AutoScaled..."          -command winAuto
  $m2 add command -label "Scaled..."              -command winScaled
  $m2 add command -label "Two D..."               -command winTwoD
  $m2 add command -label "Multiplot..."           -command winMulti

  $m add cascade -label Draw -menu $m.draw
  set m2 [menu $m.draw]
  
  $m2 add command -label Axes                     -command "axes {Axes}"
  $m2 add command -label "Axes..."                -command "axesOptions {Axes}"
  $m2 add command -label Graticule                -command "axes {Graticule}"
  $m2 add command -label "Graticule..."       -command "axesOptions {Graticule}"
  $m2 add command -label "Title"                  -command titleOptions
  $m2 add command -label "Lables"                 -command labelOptions
  $m2 add command -label "Line"                   -command lineOptions
  $m2 add command -label "Polygon"                -command polygonOptions
  $m2 add command -label "Text"                   -command textOptions
  $m2 add command -label "Graph"                  -command graphOptions
  $m2 add command -label "Histogram"              -command histOptions
  $m2 add command -label "Errors"                 -command errorOptions
  $m2 add command -label "Markers"                -command markerOptions
  $m2 add command -label "Multi_Plot"             -command multiOptions
  $m2 add command -label "Cell"                   -command cellOptions
  $m2 add command -label "CellArray"              -command cellArrayOptions
  $m2 add command -label "CellFunction"           -command cellFuncOptions
  $m2 add command -label "Cell Wedge"             -command cellwedgeOptions
  $m2 add command -label "Contour"                -command contOptions
  $m2 add command -label "ContourArray"           -command contArrayOptions
  $m2 add command -label "ContourFuntion"         -command contFuncOptions
  $m2 add command -label "LabelContour"           -command contLabOptions

  $m add command -label "Delete..."               -command deleteOptions
  $m add command -label "Redraw..."               -command redrawOptions
  $m add command -label "new_draw..."             -command newDrawOptions
  $m add command -label "Undraw..."               -command undrawOptions
  $m add command -label "Get Cursor"              -command getCursor
  
  pack $dev.box $dev.annotate -side left -fill x -expand y 

}

