proc axes {which device} {
  global devNum
  set tmp [string trim $device .dev]
  set output [smalltalk "|tmp temp a|
	  temp _ ((gXUUgraphics at: #gXcurrentgraphics) tclselect: Udevice$tmp).
	  (temp isNil)
	  ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: temp.
               tmp _ ( OneD$which new create).
	       ((gXUUgraphics at: #gXcurrentwindow) = nil)
	       ifTrue:\['DRAW ERROR, ' pren.
	   	        'Window has not been created' prinl\]
	       ifFalse:\[((gXUUgraphics at: #gXcurrentwindow) addToList: tmp).
	               a _ ((gXUUgraphics at: #gXcurrentwindow) getNumber: nil).
		        (gXUUgraphics at: #gXcurrentwindow) drawOnTop: a\]\]!"]

testOutput $output
}

proc OneDAxes {instvars class} {
  global axes font_options font_label colour_options colour_label line_label \
 	 line_options
  set axes .axesOptions
  array set instarray $instvars
  catch {destroy $axes}
  toplevel $axes
  wm title $axes "Alter $class"

  frame $axes.buttons
  frame $axes.radio
  frame $axes.radio.one
  frame $axes.radio.two
  frame $axes.radio.three
  frame $axes.radio.four
  frame $axes.radio.five
  frame $axes.tle

  pack $axes.buttons -side bottom
  pack $axes.radio -side left
  pack $axes.radio.one -side top
  pack $axes.radio.two -side top
  pack $axes.radio.three -side top
  pack $axes.radio.four -side top
  pack $axes.radio.five -side top
  pack $axes.tle -side top

  tixButtonBox $axes.box -orientation horizontal
  $axes.box add ok     -text OK      	-command "drawAxes {$instvars} "
  $axes.box add cancel -text Cancel  	-command "catch {destroy $axes}"

  pack $axes.box -side bottom -fill x -expand yes 

  foreach type {xlog xlinear} {
    radiobutton $axes.radio.five.$type -text $type -variable xlog \
        -relief flat -value $type
    pack $axes.radio.five.$type -side left -padx 0
  }
  foreach type {ylog ylinear} {
    radiobutton $axes.radio.four.$type -text $type -variable ylog \
        -relief flat -value $type
    pack $axes.radio.four.$type -side left -padx 0
  }
  foreach type {xnum noxnum} {
    radiobutton $axes.radio.one.$type -text $type -variable xnum \
        -relief flat -value $type
    pack $axes.radio.one.$type -side left -padx 0
  }
  foreach type {ynum noynum} {
    radiobutton $axes.radio.two.$type -text $type -variable ynum \
        -relief flat -value $type
    pack $axes.radio.two.$type -side left -padx 0
  }
  foreach type {yhoriz yvertical} {
    radiobutton $axes.radio.three.$type -text $type -variable yhoriz \
        -relief flat -value $type
    pack $axes.radio.three.$type -side left -padx 0
  }

  if {$instarray(xnum) == 1} {
    $axes.radio.one.xnum select
  } else {
    $axes.radio.one.noxnum select
  }
  if {$instarray(ynum) == 1} {
    $axes.radio.two.ynum select
  } else {
    $axes.radio.two.noynum select
  }
  if {$instarray(yhoriz) == 1} {
    $axes.radio.three.yhoriz select
  } else {
    $axes.radio.three.yvertical select
  }
  if {$instarray(ylog) == 0} {
    $axes.radio.four.ylinear select
  } else {
    $axes.radio.four.ylog select
  }
  if {$instarray(xlog) == 0} {
    $axes.radio.five.xlinear select
  } else {
    $axes.radio.five.xlog select
  }

set colour $instarray(colour)
set quality $instarray(quality)
set linetype $instarray(type)
set size $instarray(charsize)
set thickness $instarray(lineThickness)

  tixOptionMenu $axes.colour -label "Colour" -variable colour 
  foreach opt $colour_options {
        $axes.colour add command $opt -label $colour_label($opt) 
  }

  tixOptionMenu $axes.linetype -label "Line Type" -variable linetype
  foreach opt $line_options {
        $axes.linetype add command $opt -label $line_label($opt)
  }

  tixOptionMenu $axes.quality -label "Text Font" -variable quality 
  foreach opt $font_options {
        $axes.quality add command $opt -label $font_label($opt)
  }
  $axes.colour config -value $colour
  $axes.linetype config -value $linetype
  $axes.quality config -value $quality

  tixLabelEntry $axes.tle.size 	    -label "Text Size" 	-labelside left
  tixLabelEntry $axes.tle.thickness -label "Line Width"	-labelside left

set size $instarray(charsize)
set thickness $instarray(lineThickness)

  $axes.tle.size      subwidget entry config -textvariable size 
$axes.tle.size subwidget entry delete 0 end
$axes.tle.size subwidget entry insert 0 $size
  $axes.tle.thickness subwidget entry config -textvariable thickness
$axes.tle.thickness subwidget entry delete 0 end
$axes.tle.thickness subwidget entry insert 0 $thickness

  pack $axes.colour $axes.tle.size $axes.quality $axes.tle.thickness \
       $axes.linetype -expand yes -fill x -side top

}

proc drawAxes {instvars} {
  global colour size quality thickness linetype axes xlog ylog xnum ynum yhoriz 

array set instarray $instvars
  set size [string trim $size]
  if {[string len $size] == 0} {
    set size $instarray(charsize)
  }

  set thickness [string trim $thickness]
  if {[string len $thickness] == 0} {
    set thickness $instarray(lineThickness)
  }

  if {[string match ynum $ynum] == 1} {
    set ynum 1
  } else {
    set ynum 0
  }

  if {[string match xnum $xnum] == 1} {
    set xnum 1
  } else {
    set xnum 0
  }

  if {[string match xlog $xlog] == 1} {
    set xlog 1
  } else {
    set xlog 0
  }

  if {[string match ylog $ylog] == 1} {
    set ylog 1
  } else {
    set ylog 0
  }

  if {[string match yhoriz $yhoriz] == 1} {
    set yhoriz 1
  } else {
    set yhoriz 0
  }


  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]
  
  set output [smalltalk "|tmp temp|
	   tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object 
		   and: $picture with: '$objectid').
	   (tmp isNil)
	   ifFalse:\[ temp _ (tmp xlog: $xlog; ylog: $ylog; xnum: $xnum;  
		    	    colour: $colour; ynum: $ynum; yhoriz: $yhoriz; 
			    lineThickness: $thickness; quality: $quality; 
			    type: $linetype; charsize: $size; create).
		((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]
	   ifTrue:\['Object has not been altered' prinl\] !"]

  testOutput $output	
  destroy $axes
}
