proc contour {cell} {
  global devNum graph library function contourType name primary

#set function regexp

set devNum [expr $devNum + 1]
set cont .dev$devNum
set devNum [expr $devNum + 1]
destroy $primary
toplevel $cont -borderwidth 20 -relief ridge
wm title $cont "$cell Plot"

pgwindow $cont.p$devNum -width 600 -height 700 -background White
pack $cont.p$devNum
set output [smalltalk "|tmp dev|
             Smalltalk at:#Udevice$devNum put: nil!
             Udevice$devNum _ (Device new: 'tk').
             gXUUgraphics at: #gXcurrentdevice put: (Udevice$devNum Open).
        ((gXUUgraphics at: #gXcurrentgraphics) addToDeviceList: Udevice$devNum).
               gXUUstatus _ 1.
               gXUUgraphics at: #gXcurrentpicture put: nil.
               gXUUgraphics at: #gXcurrentwindow put: nil!"]
  testOutput $output

  tixButtonBox $cont.box -orientation horizontal
  $cont.box add alter -text Alter      	-command "contAlter {$cont}"
  $cont.box add cursor -text Cursor    	-command "cursor {$cont}"
  $cont.box add hardcopy -text Hardcopy	-command "hardcopy {$cont}"
  $cont.box add zoom -text Zoom 	-command "zoom {$cont} {$name}"
  $cont.box add redraw -text Redraw 	-command "redraw {$cont} {$name}"
  $cont.box add cancel -text Cancel 	-command "cancel {$cont}"

  menubutton $cont.annotate -text Annotate -menu $cont.annotate.menu
  set m [menu $cont.annotate.menu]
  $m add command -label Graticule -command "axes {Graticule} {$cont}"
  $m add command -label Text 	  -command "text {$cont}"

  pack $cont.box $cont.annotate -side right -expand yes -fill x

  set output [gcl "res=fields()
	      res.file=\"$name\"
	      module/load \"$library\" 
	      data=module:execute(\"g_get_2d_file\",res)
	      unfix data.s 1000.0
	      win_twod 0.2 0.9 0.2 0.9 data.x data.y"]
  testOutput $output
  if {[string match $cell cell] == 1} {
    set output [gcl "col=read:ascii:columns(\"/usr/users/rla/genie/examples/report/rainbow.dat\", \"R,G,B\")
                table=allocate_colours(col.r,col.g,col.b,80,1.0,1.0)"]
    if { $contourType == 1} {
      set output [gcl "cell/draw data.s table"]
    } elseif {$contourType == 2} {
      set output [gcl "cell_array/draw/sqrt/smooth data.s table data.x data.y"]
    } else {
      set output [gcl "cell_function/draw data.s table $function"]
    } 
    gcl "win_twod 0.1 0.15 0.1 0.15 data.x data.y
         cell_wedge/draw object=0 window=0 "
    gcl "deallocate_colours table=table "
  } else {
    set output [gcl "cont=5"]
    if { $contourType == 1} {
      set output [gcl "contour/draw data.s _ cont"]
    } elseif {$contourType == 2} {
      set output [gcl "contour_array/draw data.s _ cont data.x data.y"]
    } else {
      set output [gcl "contour_function/draw data.s _ cont $function"]
    }
  } 
  testOutput $output
  gcl "axes/draw"

}

