proc deviceOptions {} {
  global device devNum device_options device_label
  set device .device$devNum
  catch {destroy $device}
  toplevel $device
  wm title $device "Device Open Options"

  tixOptionMenu $device.type -label "Device Type: " -variable deviceType
  foreach opt $device_options {
	$device.type add command $opt -label $device_label($opt)
  }
  pack $device.type -expand yes -fill x

  frame $device.tle
  pack $device.tle

  tixLabelEntry $device.tle.height -label Height -labelside left
  tixLabelEntry $device.tle.width  -label Width  -labelside left

  $device.tle.height subwidget entry config -textvariable deviceHeight
  $device.tle.width  subwidget entry config -textvariable deviceWidth
  
  tixButtonBox $device.box -orientation horizontal
  $device.box add ok     -text OK     -command processName 
  $device.box add cancel -text Cancel -command "destroy $device" 

  pack $device.tle.height $device.tle.width  -expand yes -fill x -side top
  pack $device.box -side bottom -expand yes -fill x
}

proc deviceOpen {} {
  global devNum
  
  set devNum [expr $devNum + 1]
  set output [smalltalk " |tmp dev|
	     Smalltalk at:#Udevice$devNum put: nil!
	     Udevice$devNum _ (Device new: 'tk').
             gXUUgraphics at: #gXcurrentdevice put: (Udevice$devNum Open).
        ((gXUUgraphics at: #gXcurrentgraphics) addToDeviceList: Udevice$devNum).
             gXUUstatus _ 1.
             gXUUgraphics at: #gXcurrentpicture put: nil.
             gXUUgraphics at: #gXcurrentwindow put: nil !"]
  testOutput $output
  set devNum [expr $devNum + 1]
}

proc processName {} {
  global device deviceType deviceWidth deviceHeight devNum

  if {[string match *.* $deviceHeight] == 0} {
    set deviceHeight 7.0
  }
  if {[string match *.* $deviceWidth] == 0} {
    set deviceWidth 8.0
  }

  if {[string match tk $deviceType] == 1} {
    adevice $deviceWidth $deviceHeight

  } else {
    set devNum [expr $devNum + 1]
    set output [smalltalk "|dev tmp|
	      Smalltalk at: #Udevice$devNum put: nil!
  	      Udevice$devNum _ (Device new: '$deviceType').
	       gXUUgraphics at: #gXcurrentdevice put: (Udevice$devNum Open).
	((gXUUgraphics at: #gXcurrentgraphics) addToDeviceList: Udevice$devNum).
	       ((gXUUgraphics at: #gXcurrentdevice) Clear).
               gXUUgraphics at: #gXcurrentpicture put: nil.
               gXUUgraphics at: #gXcurrentwindow put: nil!" ]
    testOutput $output
  }
  destroy $device
  
}

proc deviceClose {aName} {
  global devNum
  set aNum [string trim $aName .dev]
  set output [smalltalk "|tmp temp|
	tmp _ ((gXUUgraphics at: #gXcurrentgraphics) tclSelect: Udevice$aNum).
	   (tmp isNil)
	   ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: tmp.
	      	     temp _ (gXUUgraphics at: #gXcurrentdevice).  
	      	  tmp _ ((gXUUgraphics at: #gXcurrentgraphics) closeDown: temp).
		     (tmp isNil) 
		     ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: tmp\]\]!"]
  testOutput $output

  destroy $aName
  set devNum [expr $devNum - 1]
}

proc deviceClear {} {
  set output [smalltalk "((gXUUgraphics at: #gXcurrentdevice) isNil)
	     ifFalse:\[(gXUUgraphics at: #gXcurrentdevice put:
                                (gXUUgraphics at: #gXcurrentdevice) Clear)\]
	     ifTrue:\['ERROR, ' pren.
                           'Device is Closed' prinl\]!"]
  testOutput $output
}

