#======================================================================	#
#======================================================================	#
#									#
#	NOTE: All of the underlying code is changing, namely		#
#	      undraw, redraw, delete, and pic_add.  UNDRAW and 		#
#	      REDRAW is used in this code and will need to be 		#
#	      changed accordingly.					#
#									#
#======================================================================	#
#======================================================================	#


proc display {filename mark} {
  global devNum lcolour tcolour lwidth tsize start finish test graph dev \
  	 fileNumber
  
  set path $filename
  if { [string match raw $test] == 1} {
 
    set devNum [expr $devNum + 1]
    set dev .dev$devNum
    catch {destroy $dev}
    toplevel $dev -borderwidth 10 -relief ridge
    wm title $dev "Display"
    
    set lwidth [string trim $lwidth]
    if {[string len $lwidth] == 0} {
      set lwidth _
    }
    set tsize [string trim $tsize]
    if {[string len $tsize] == 0} {
      set tsize _
    }
   set start [string trim $start]
  if {[string len $start] == 0} {
    set start 1
  }
  set finish [string trim $finish]
  if {[string len $finish] == 0} {
    set finish 1
  }
    if {[expr $start > $finish] == 1} {
      set tmp $start
      set start $finish
      set finish $tmp
    }
    
    set Width 600
    set Height 600
    pgwindow $dev.p$devNum -width $Width -height $Height -background White \
	     -relief flat
    pack $dev.p$devNum
    set temp device$devNum
    set output [smalltalk "|tmp dev|
  	     Smalltalk at:#Udevice$devNum put: nil!
  	     Udevice$devNum _ (Device new: 'tk').
      	     gXUUgraphics at: #gXcurrentdevice put: (Udevice$devNum Open).
        ((gXUUgraphics at: #gXcurrentgraphics) addToDeviceList: Udevice$devNum).
               gXUUstatus _ 1.
               gXUUgraphics at: #gXcurrentpicture put: nil.
               gXUUgraphics at: #gXcurrentwindow put: nil!"]
    testOutput $output
    
    tixButtonBox $dev.box -orientation horizontal
    $dev.box add alter -text Alter	-command "disAlter {$dev} {mark}"
    $dev.box add cursor -text Cursor	-command "cursor {$dev}"
    $dev.box add hardcopy -text Hardcopy	-command "hardcopy {$dev}"
    $dev.box add zoom -text Zoom		-command "zoom {$dev} {$path}"
    $dev.box add redraw -text Redraw 	-command "redraw {$dev} {$path}"
    $dev.box add cancel -text Cancel -command "cancel {$dev}"

    menubutton $dev.annotate -text Annotate -menu $dev.annotate.menu
    set m [menu $dev.annotate.menu]
    $m add command -label Graticule -command "axes {Graticule} {$dev}"
    $m add command -label Text -command "text {$dev}"
    
    pack $dev.box $dev.annotate -side right -expand yes -fill x
    set pic$fileNumber $path

    gcl "set/file \"$path\""
    gcl "d=s($start)"
    set $fileNumber [expr $fileNumber + 1]
    if {[string match $mark 0 ] == 1 } {
      gcl "display _ _ _ _ _ _ _ _ _ s($start)"
    } else {
      gcl "multiplot $start:$finish"
    }
    set output [smalltalk "Udevice$devNum associate: 
					(gXUUgraphics at: #gXcurrentpicture)!"]
    testOutput $output 
  } else {
    after idle {.dialog1.msg config -wraplength 1i}
    set i [tk_dialog .dialog1 "Error" "File is not of Type RAW" error 0 Ok]
  }
}
 
proc cancel {aName} {
  global devNum
  set aNum [string trim $aName .dev]
  set output [smalltalk "|tmp temp|
        tmp _ ((gXUUgraphics at: #gXcurrentgraphics) tclSelect: Udevice$aNum).
           (tmp isNil)
           ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: tmp.
                     temp _ (gXUUgraphics at: #gXcurrentdevice).
                  tmp _ ((gXUUgraphics at: #gXcurrentgraphics) closeDown: temp).
                     (tmp isNil)
                     ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: tmp\]\]!"]
  testOutput $output

  destroy $aName
  set devNum [expr $devNum - 1]
} 

proc disAlter {dev display} {
  global d colour colour_options symbol_label colour_label symbol_options \
         graphType_options graphType_label change start finish
  set change .disalter
  catch {destroy $change}
  toplevel $change
  wm title $change "Alter Display Options"
  set aNum [string trim $dev .dev]
set start 1
set finish 1

  set output [smalltalk "|tmp temp|
        tmp _ ((gXUUgraphics at: #gXcurrentgraphics) tclSelect: Udevice$aNum).
           (tmp isNil)
           ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: tmp\]!"]

  testOutput $output

  set number [gcl "printn get(\"NSP1\")"]
  set number [lindex $number 0]
  set number [string trim $number]

  tixLabelEntry $change.width   -label "Line Width"    -labelside left
  tixLabelEntry $change.height  -label "Text Size"     -labelside left
  tixLabelEntry $change.bin     -label "Binning"       -labelside left

  $change.width   subwidget entry config -textvariable width
  $change.height  subwidget entry config -textvariable height
  $change.bin     subwidget entry config -textvariable bin

  tixOptionMenu $change.colour -label "Colour" -variable colour
  foreach opt $colour_options {
        $change.colour add command $opt -label $colour_label($opt)
  }

  tixOptionMenu $change.tcolour -label "Text Colour" -variable tcolour
    foreach opt $colour_options {
    $change.tcolour add command $opt -label $colour_label($opt)
  }

  tixOptionMenu $change.markers -label "Marker Symbol" -variable markers
  foreach opt $symbol_options {
        $change.markers add command $opt -label $symbol_label($opt)
  }

  tixOptionMenu $change.graphType -label "Graph Type" -variable graphType
  foreach opt $graphType_options {
        $change.graphType add command $opt -label $graphType_label($opt)
  }

  $change.colour config -value 1
  $change.tcolour config -value 1

  frame $change.1
  frame $change.2
  frame $change.3
  frame $change.4
  frame $change.5
  pack $change.1 $change.2 $change.3 $change.4 $change.5 \
       $change.colour $change.tcolour $change.markers $change.graphType \
       $change.width $change.height $change.bin -fill x -side top

if {[string match $display 0] == 1} {
    tixControl $change.spectra -label "Spectra Number: " -integer true \
          -variable start -min 1 -max $number -value $number
    pack $change.spectra -side top -fill x 
  } else {
    tixControl $change.first -label "Spectra Number From: " \
	  -integer true -variable start -min 1 -max $number -value $start

    tixControl $change.last -label "To: " -integer true \
	  -variable finish -min 1 -max $number -value $finish
    pack $change.first $change.last -side top -fill x
  }

  foreach type {xlog xlinear} {
    radiobutton $change.1.$type -text $type -variable xlog -value $type
    pack $change.1.$type -side left
  }

  foreach type {ylog ylinear} {
    radiobutton $change.2.$type -text $type -variable ylog -value $type
    pack $change.2.$type -side left
  }

  foreach type {roundX noroundX} {
    radiobutton $change.3.$type -text $type -variable rx -value $type
    pack $change.3.$type -side left
  }
  foreach type {roundY noroundY} {
    radiobutton $change.4.$type -text $type -variable ry -value $type
    pack $change.4.$type -side left
  }

  foreach type {header noheader} {
    radiobutton $change.5.$type -text $type -variable header -value $type
    pack $change.5.$type -side left
  }

  $change.1.xlinear select
  $change.2.ylinear select
  $change.3.roundX select
  $change.4.roundY select
  $change.5.header select

  tixButtonBox $change.box -orientation horizontal
  $change.box add redisplay -text "Re-Display" -command "redisplay {display}"
  $change.box add cancel -text Cancel -command "catch {destroy $change}"

  pack $change.box -side bottom -fill x
}

proc redisplay {display} {
  global bin markers tcolour colour height width wksp d graphType \
         start finish header ry rx xlog ylog change

  destroy $change
  set width [string trim $width]
  if {[string len $width] == 0} {
    set width _
  }
  set height [string trim $height]
  if {[string len $height] == 0} {
    set height _
  }

  if {[string len $bin] != 0} {
    set output [gcl "alter/binning $bin"]
    testOutput $output
  }

#  The following code allows the toggle function to work without
#  mistaking the state of DISPLAY.
#  This is only temporary, since it is depending on the workspace SDJ_GW


  set xl1 [gcl "printn _sdj_gw.xlog"]
  set yl1 [gcl "printn _sdj_gw.ylog"]
  set rx1 [gcl "printn _sdj_gw.xrounding"]
  set ry1 [gcl "printn _sdj_gw.yrounding"]
  set h1  [gcl "printn _sdj_gw.header"]

  set xl1 [lindex $xl1 0]
  set yl1 [lindex $yl1 0]
  set rx1 [lindex $rx1 0]
  set ry1 [lindex $ry1 0]
  set h1 [lindex $h1 0]

  set xl1 [string trim $xl1 ]
  set yl1 [string trim $yl1 ]
  set rx1 [string trim $rx1 ]
  set ry1 [string trim $ry1 ]
  set h1 [string trim $h1 ]

  if {([string match $xlog xlog] == 1) && ([string match $xl1 0] == 1)} {
     set output [gcl "toggle/logx"]
     testOutput $output
  }
  if {([string match $xlog xlinear] == 1) && ([string match $xl1 1] == 1)} {
    set output [gcl "toggle/logx"]
     testOutput $output
  }
  if {([string match $ylog ylog] == 1) && ([string match $yl1 0] == 1)} {
    set output [gcl "toggle/logy"]
     testOutput $output
  }
  if {([string match $ylog ylinear] == 1) && ([string match $yl1 1] == 1)} {
    set output [gcl "toggle/logy"]
     testOutput $output
  }
  if {([string match $rx roundX] == 1) && ([string match $rx1 0] == 1)} {
    set output [gcl "toggle/rx"]
     testOutput $output
  }
  if {([string match $rx noroundX] == 1) && ([string match $rx1 1] == 1)} {
    set output [gcl "toggle/rx"]
     testOutput $output
  }
  if {([string match $ry roundY] == 1) && ([string match $ry1 0] == 1)} {
    set output [gcl "toggle/ry"]
     testOutput $output
  }
  if {([string match $ry noroundY] == 1) && ([string match $ry1 1] == 1)} {
    set output [gcl "toggle/ry"]
     testOutput $output
  }
  if {([string match $header header] == 1) && ([string match $h1 0] == 1)} {
    set output [gcl "toggle/header"]
     testOutput $output
  }
  if {([string match $header noheader] == 1) && ([string match $h1 1] == 1)} {
    set output [gcl "toggle/header"]
     testOutput $output
  }
#gcl "undraw/all"
gcl "picture"
  if {[string match 0 $display] == 1} {
    if {[string match 1 $graphType] == 1} {
      set output [gcl "display _ _ _ _ _ _ _ _ _ s($start) _ _ _ _ $colour $width $tcolour $height"]
      testOutput $output
    }
    if {[string match 2 $graphType] == 1} {
      set output [gcl "display/line _ _ _ _ _ _ _ _ _ s($start)  _ _ _ _ $colour $width $tcolour $height"]
      testOutput $output
    }
    if {[string match 3 $graphType] == 1} {
      set output [gcl "display/errors _ _ _ _ _ _ _ _ _ s($start) _ _ _ _ $colour $width $tcolour $height"]
      testOutput $output
    }
    if {[string match 4 $graphType] == 1} {
      set output [gcl "alter/markers $markers"]
      testOutput $output
      set output [gcl "display/markers _ _ _ _ _ _ _ _ _ s($start)  _ _ _ _ $colour $width $tcolour $height"]
      testOutput $output
    }
  } else {
    set output [gcl "multiplot $start:$finish _ _ $colour _ $width $tcolour $height"]
    testOutput $output
  }

}

proc hardcopy {dev} {
  global print
  set print .hardcopy
  catch {destroy $print}
  toplevel $print
  wm title $print "Print Options"

  tixLabelEntry $print.file -label "File Name" -labelside left
  tixLabelEntry $print.printer -label "Printer Name" -labelside left

  $print.file subwidget entry config -textvariable file
  $print.printer subwidget entry config -textvariable printer

  tixControl $print.copies -label "Number of Copies" -integer true \
        -variable copies -min 1 -max 999 -value 1

  tixButtonBox $print.box -orientation horizontal
    $print.box add ok -text Print -command "ok {$dev}" -width 6
    $print.box add cancel -text Cancel -command "destroy $print" -width 6

  pack $print.file $print.printer -side top -fill x
  pack $print.box -side bottom -fill x

  frame $print.top
  frame $print.middle
  frame $print.bottom
  pack $print.top $print.middle $print.bottom $print.copies -side top \
       -expand yes -fill x

  label $print.top.label -text "Save To: "
  pack $print.top.label -side left
  foreach type {file printer both} {
    radiobutton $print.top.$type -text $type -variable copy -value $type
    pack $print.top.$type -side left
  }

  foreach type {colour b/w} {
    radiobutton $print.middle.$type -text $type -variable colour -value $type
    pack $print.middle.$type -side right
  }

  foreach type {landscape portrait} {
    radiobutton $print.bottom.$type -text $type -variable orientation \
                -value $type
    pack $print.bottom.$type -side right
  }

  $print.top.both select
  $print.middle.colour select
  $print.bottom.portrait select

}

proc ok {dev} {
  global file print printer copies orientation colour copy


  if {[string match $colour colour] == 1} {
    set colour c
  } else {
    set colour ""
  }

  if {[string match $orientation landscape] == 1} {
    set orientation v
  } else {
    set orientation ""
  }
  set ps ps
  set method $orientation$colour$ps

# Setting the current device

  set aNum [string trim $dev .dev]
  set output [smalltalk "|temp|
         temp _ ((gXUUgraphics at: #gXcurrentgraphics) tclSelect: Udevice$aNum).
              (temp isNil)
             ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: temp\]!"]
  testOutput $output

  set output [gcl "hardcopy \"$file\" \"$method\" pic(0)"]
  testOutput $output
  if {[string match $copy printer] == 1 || [string match $copy both] == 1} {
    set printer [string trimleft $printer lpr]
    set printer [string trim $printer ]

    for {set i 0} {$i < $copies} {incr i 1} {
# NEED TO CHANGE THIS LINE, SO THEN IT CAN COPE WITH ALL TYPES
# OF COMPUTERS
      exec "lpr" $printer $file
    }
  }
  destroy $print
}

proc redraw {dev path} {
  global start 
  set aNum [string trim $dev .dev]
  set output [smalltalk "|tmp temp|
        tmp _ ((gXUUgraphics at: #gXcurrentgraphics) tclSelect: Udevice$aNum).
  	     (tmp isNil)
	     ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: tmp.
		  temp _ ((gXUUgraphics at: #gXcurrentdevice) getPictureNumber).
  	        temp _ ((gXUUgraphics at: #gXcurrentgraphics) getPicture: temp).
		(temp isNil)
	ifFalse:\[(gXUUgraphics at: #gXcurrentpicture put: temp)\]\]!"]
  testOutput $output
#  gcl "undraw/all"
gcl "picture"
  gcl "set/file \"$path\""
  set output [gcl "display s($start)"]
  testOutput $output
}

proc zoom {dev path} {
  global fileNumber
  set aNum [string trim $dev .dev]
  set output [smalltalk "|tmp temp|
        tmp _ ((gXUUgraphics at: #gXcurrentgraphics) tclSelect: Udevice$aNum).
  	     (tmp isNil)
	     ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: tmp.
		  temp _ ((gXUUgraphics at: #gXcurrentdevice) getPictureNumber).
  	        temp _ ((gXUUgraphics at: #gXcurrentgraphics) getPicture: temp).
		(temp isNil)
	ifFalse:\[(gXUUgraphics at: #gXcurrentpicture put: temp)\]\]!"]
  testOutput $output
gcl "undraw/all"
gcl "set/file \"$path\""
  set output [gcl "zoom"]
  testOutput $output
}

proc cursor {dev} {
  set aNum [string trim $dev .dev]

set output [smalltalk "|tmp temp|
        tmp _ ((gXUUgraphics at: #gXcurrentgraphics) tclSelect: Udevice$aNum).
           (tmp isNil)
           ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: tmp.
		     tmp _ ((gXUUgraphics at: #gXcurrentpicture) 
						    getCursor: 0.0 and: 0.0).
		      tmp prnl\]!"]

  set norm [lindex $output 0]
  after idle {.dialog1.msg config -wraplength 3i -width 30 -height 10 }
  set i [tk_dialog .dialog1 "Get Cursor" $norm info 0 Ok]
}
