tixWidgetClass tixFileList {
  -classname TixFileList
  -superclass tixScrolledHList
  -method {
  }
  -flag { -browsecmd -command -directory -root -rootname -value
  }
  -forcecall { -directory
  }
  -configspec {
  	{-browsecmd browseCmd BrowseCmd ""}
  	{-command command Command ""}
  	{-directory directory Directory ""}
  	{-root root Root ""}
	{-rootname rootName RootName ""}
	{-value value Value ""}
  }
  -default {
	{.scrollbar			auto}
	{*borderWidth			1}
	{*hlist.background		#c3c3c3}
	{*hlist.indent			7}
	{*hlist.relief			sunken}
	{*hlist.height			10}
	{*hlist.width			20}
	{*hlist.padX			2}
	{*hlist.padY			0}
	{*hlist.wideSelection		0}
	{*hlist.drawBranch		0}
	{*hlist.highlightBackground	#d9d9d9}
	{*hlist.itemType		imagetext}
	{*hlist.takefocus		1}
  }
}

proc tixFileList:InitWidgetRec {w} {
  upvar #0 $w data
  tixChainMethod $w InitWidgetRec
}

proc tixFileList:ConstructWidget {w} {
  upvar #0 $w data
  tixChainMethod $w ConstructWidget

  $data(w:hlist) config -separator [tixFSSep] -selectmode "dragdrop"
  
}

proc tixFileList:SetBindings {w} {
  upvar #0 $w data

  tixChainMethod $w SetBindings

  $data(w:hlist) config \
	-browsecmd "tixFileList:Browse $w" \
	-command "tixFileList:Command $w"

  set index [lindex [$data(w:hlist) curselection] 0]
  if {$index == ""} {
    set index 0
  }

  set file [$data(w:hlist) get $index]
  tixSetSilent $data(w:hlist) $file

  set data(-value) [tixNativeName [tixSubFolder \
	[tixFileIntName $data(-directory)] [tixFileIntName $file]]]

  if {$data(-browsecmd) != ""} {
    tixEvalCmdBinding $w $data(-browsecmd) "" $data(-value)
  }
}

proc tixFileList:Browse {w args} {
  upvar #0 $w data

  uplevel #0 set TRANSPARENT_GIF_COLOR [$data(w:hlist) cget -bg]
  set file [tixEvent flag V]
  set value [$data(w:hlist) info data $file]
  set data(-value) $value
  
  tixDirList:HighLight $w $file
 
  set data(file) $file
  set data(-value) $value

  tixFileList:CallBrowseCmd $w $data(-value)
}

proc tixFileList:Command {w args} {
  upvar #0 $w data

  set file [tixEvent value]
  set value [$data(w:hlist) info data $file ]
  set data(-value) $value

  tixDirList:HighLight $w $file
  tixFileList:CallCommand $w $data(-value)
}

proc tixFileList:CallBrowseCmd {w value} {
  upvar #0 $w data

  if {$data(-browsecmd) != ""} {
    set bind(specs) "%V"
    set bind(%V) $value
    tixEvalCmdBinding $w $data(-browsecmd) bind $value
  }
}

proc tixFileList:CallCommand {w value} {
  upvar #0 $w data

  if {$data(-command) != ""} {
    set bind(specs) "%V"
    set bind(%V) $value
    tixEvalCmdBinding $w $data(-command) bind $value
  }
}

