proc get_filename {filename} {
  global name test graph 

    set name $filename
    set output [gcl "set/file \"$name\""]
    testOutput $output
    set test [gcl "get 1 \"$name\""]
    set test [lindex $test 1] 
    if {[string match {* raw*} $test] == 1} { 
      set test "raw"
      $graph.but.display config -activebackground Green
      $graph.but.multiplot config -activebackground Green
      $graph.but.cell config -activebackground Green
      $graph.but.contour config -activebackground Green
      $graph.box.view config -activebackground Green
    } 
    if {[string match {* intermediate*} $test] == 1} {
      set test "raw"
      $graph.but.display config -activebackground Green
      $graph.but.multiplot config -activebackground Green
      $graph.but.cell config -activebackground Green
      $graph.but.contour config -activebackground Green
      $graph.box.view config -activebackground Green
    }
    if {[string match {* ASCII*} $test] == 1} {
      set test "ASCII"
      $graph.but.display config -activebackground Red
      $graph.but.multiplot config -activebackground Red
      $graph.but.cell config -activebackground Green
      $graph.but.contour config -activebackground Green
      $graph.box.view config -activebackground Green
    }
}

proc open {filename} {
global name specNum spec test graph
  if {[string match $filename 1] == 0} {
    set name $filename
  }
  if {[string match $name _] == 1} {
    errorMess "A FileName is not Specified"
  } else {
    if {[string match raw $test] == 0} {
      exec "dxnotepad" $name -bg grey -fg black &
      set name _
      set filename _
    } else {
      set output [gcl "set/file \"$name\""]
      testOutput $output
      getSpectra
    }
  }
} 

proc getSpectra {} {
  global specNum spec number
  set spec .findSpectra 
      catch {destroy $spec}
      toplevel $spec
      set number [gcl "printn get(\"NSP1\")"]
      set number [lindex $number 0]
      set number [string trim $number]
      tixControl $spec.spectra -label "Spectra Number: " -integer true \
	-variable specNum -min 1 -max $number -value 1
      button $spec.ok -text OK -command "testSpectra "
      button $spec.cancel -text Cancel -command "catch {destroy $spec}"
      pack $spec.cancel $spec.ok -side left -padx 0 -pady 50
      pack $spec.spectra -side top -padx 50 -pady 0
}

proc testSpectra {} {
  global spec name getSpectra specNum 
  set tmp [gcl "printn s($specNum)"]
  set tmp [lindex $tmp 0]
  set view .win
  catch {destroy .findSpectra}
  catch {destroy $view}
  toplevel $view
  wm title $view "$name spectra: $specNum"
  tixScrolledWindow $view.tmp -height 600 -width 600
  pack $view.tmp -expand yes -fill both
  set f [$view.tmp subwidget window]
  label $f.label -text $tmp -justify left
  pack $f.label -expand yes -fill both

  tixButtonBox $view.box -orientation horizontal
    $view.box add previous -text Previous -command "previous"
    $view.box add cancel -text Cancel -underline 0 -command "destroy $view" \
	-width 12
    $view.box add next -text Next -command "next"
    pack $view.box -side bottom -fill both -expand yes
  
}

proc previous {} {
  global specNum
  if {[string match $specNum 1] == 1} {
	errorMess {There are no previous spectra}
  } else {
    set specNum [expr $specNum - 1]
    testSpectra 
  }
}

proc next {} {
  global specNum number
  if {[string match $specNum $number] == 1} {
	errorMess "There are only $number spectra"
  } else {
    set specNum [expr $specNum + 1]
    testSpectra 
  }
}

proc getX {} {
  global specNum spec view tmp
  gcl "w=s($specNum)"
  set tmp [gcl "printn w.y"]  
}

proc Mark { x y W } {
    global state
    set state($W,obj) [$w find closest $x $y]
    set state($W,x) $x
    set state($W,y) $y
}

proc Drag { x y W } {
    global state
    set dx [expr $x - $state($W,x)]
    set dy [expr $y - $state($W,y)]
    $W move $state($W,obj) $dx $dy
    set state($W,x) $x
    set state($W,y) $y
}

proc multiplot {} {
  global name lcolour tcolour lwidth tsize start finish multi test number
  set multi .multiplotOpt
  catch {destroy $multi}
  toplevel $multi
  wm title $multi "Spectra Numbers"
  set number [gcl "printn get(\"NSP1\",\"$name\")"]
  set number [lindex $number 0]
  set number [string trim $number]
  
  frame $multi.con
  pack $multi.con -side top
  tixControl $multi.con.one -label "Spectra From: " -integer true \
	-variable start -min 1 -max $number -value 1

  tixControl $multi.con.two -label "Spectra To: " -integer true \
	-variable finish -min 1 -max $number -value $number

  pack $multi.con.one $multi.con.two -side left

  tixButtonBox $multi.box -orientation horizontal
$multi.box add ok -text OK -underline 0 -command {fileThere 1; destroy $multi} \
	-width 10
  $multi.box add cancel -text Cancel -underline 0 -command "destroy $multi" \
         -width 10
 
  pack $multi.box -side bottom -expand yes -fill x

}

proc fileThere {mark} {
  global name multi graph 
  if {[string len $name] == 0} {
    errorMess "A File has not been Specified"
  } else {
    display $name $mark 
  }
}

proc primCont {cell} {
  global name contourType_options contourType_label library test primary \
	 cellType_options cellType_labels

  after idle {.dialog1.msg config -wraplength 1i}
  set i [tk_dialog .dialog1 "Something" "$cell Not Yet Implemented" info 0 \
	 Ok]

#======================================================================	#
#======================================================================	#
#									#
#	This code does work, but the following functions		#
#	are not quite finished !!!					#
#									#
#======================================================================	#
#======================================================================	#
#
#  
#  if {[string match $test raw] == 1} {
#    drawRAWContour $cell
#  } else {
#    set primary .primaryContour
#    catch {destroy $primary}
#    toplevel $primary
#  wm title $primary "$cell Preliminaries"
#
#    if {[string match $cell cell] == 1} {
#      tixOptionMenu $primary.type -label "Cell Type: " -variable contourType
#      foreach opt $cellType_options {
#	$primary.type add command $opt -label $cellType_labels($opt)
#      }
#    } else {
#      tixOptionMenu $primary.type -label "Contour Type: " -variable contourType 
#      foreach opt $contourType_options {
#        $primary.type add command $opt -label $contourType_label($opt)
#      }
#    }
#    pack $primary.type -side top -expand yes -fill x
#
#    tixFileEntry $primary.library  -labelside left -label "Library File" \
#    	       -dialogtype tixExFileSelectDialog -variable library
#
#    tixFileEntry $primary.function -labelside left -label "Function Name" \
#    	       -dialogtype tixExFileSelectDialog -variable function
#    set tmp [tix filedialog tixExFileSelectDialog]
#    $tmp subwidget fsbox config -filetypes {
#            {{*}    {All files}}
#    	    {{*.so}	{Library Files}}
#	    {{*.f}	{Function Files}}
#      }
#
#    tixButtonBox $primary.box -orientation horizontal
#    $primary.box add ok -text Ok -command "contour {$cell}"
#    $primary.box add cancel -text Cancel -command "catch {destroy $primary}"
#
#    pack $primary.type $primary.library $primary.function $primary.box \
#         -side top -expand yes -fill x
#  }
#}

proc drawRAWContour {cell} {
  global name devNum
  set devNum [expr $devNum + 1]
  set rawCont .dev$devNum
  catch {destroy $rawCont}
  toplevel $rawCont
  wm title $rawCont "RAW Contour Plot"
  
  pgwindow $rawCont.p$devNum -width 600 -height 700 -background White \
             -relief flat
    pack $rawCont.p$devNum
    set temp device$devNum
    set output [smalltalk "|tmp dev|
             Smalltalk at:#Udevice$devNum put: nil!
             Udevice$devNum _ (Device new: 'tk').
             gXUUgraphics at: #gXcurrentdevice put: (Udevice$devNum Open).
        ((gXUUgraphics at: #gXcurrentgraphics) addToDeviceList: Udevice$devNum).
               gXUUstatus _ 1.
               gXUUgraphics at: #gXcurrentpicture put: nil.
               gXUUgraphics at: #gXcurrentwindow put: nil!"]
    testOutput $output

  tixButtonBox $rawCont.box -orientation horizontal
    $rawCont.box add alter -text Alter      -command "disAlter {$rawCont}"
    $rawCont.box add cursor -text Cursor    -command "cursor {$rawCont}"
    $rawCont.box add hardcopy -text Hardcopy      -command "hardcopy {$rawCont}"
    $rawCont.box add zoom -text Zoom          -command "zoom {$rawCont} {$name}"
    $rawCont.box add redraw -text Redraw    -command "redraw {$rawCont} {$name}"
    $rawCont.box add cancel -text Cancel -command "cancel {$rawCont}"

    menubutton $rawCont.annotate -text Annotate -menu $rawCont.annotate.menu
    set m [menu $rawCont.annotate.menu]
    $m add command -label Graticule -command "axes {Graticule $rawCont}"
    $m add command -label Text -command "text {$rawCont}"

    pack $rawCont.box $rawCont.annotate -side right -expand yes -fill x
 
set output [gcl "set/file \"$name\"
     nx=get(\"NTC1\")
     ny=get(\"NSP1\")
     w=get(1:ny)
     win_scaled 0.2 0.8 0.2 0.8 w.x\[1\] w.x\[nx\] 1.0 ny*1.0"]
if {[string match $cell cell] == 1} {
    set output [gcl "col=read:ascii:columns(\"/usr/users/rla/genie/examples/report/rainbow.dat\", \"R,G,B\")
	table=allocate_colours(col.r,col.g,col.b,30,1.0,1.0)
   	cell/draw/smooth w.y table valmax=30.0
	deallocate_colours table=table "]
    testOutput $output
  } else {
     set output [gcl "contour/draw/sqrt w.y "]
     testOutput $output
  }
  gcl "axes/draw
       labels/draw \"Time-Of-Flight (\\gms)\" \"Spectrum Number\" size=1.5"
} 
