set g_helpIndex 0
set g_helpHistory _
set g_helpFile _
set g_helpTop 0
set g_helpDir .
set g_searchPos 1.0

proc g_render {file back} {
    global g_helpIndex g_helpHistory g_helpFile g_helpTop g_helpDir
    set url $file
    if {$back != 1} {
        incr g_helpIndex
        set g_helpTop $g_helpIndex
    }
    if {$g_helpIndex > 0} {
        g_activate .help.con.buttons.back
    } else {
        g_deactivate .help.con.buttons.back
    }
    if {$g_helpIndex < $g_helpTop} {
        g_activate .help.con.buttons.forward
    } else {
        g_deactivate .help.con.buttons.forward
    }
    set fragment ""
    regexp {([^#]*)#(.+)} $file dummy file fragment
    if {$file == "" && $fragment != ""} {
        if {$fragment == "_top"} {
            .help.f.text see 1.0
        } else {
            HMgoto .help.f.text $fragment
        }
        if {$back != 1} {
            set g_helpHistory [linsert $g_helpHistory $g_helpIndex $g_helpFile$url]
        }
        return
    }
    if [catch {set handle [open $g_helpDir/$file]}] {
        return
    } 
    HMreset_win .help.f.text
	HMset_state .help.f.text -stop 1
    if {$back != 1} {
        set g_helpHistory [linsert $g_helpHistory $g_helpIndex $url]
    }
    set g_helpFile $file
    set html [read $handle]
    close $handle
    if [string match *.htm* $file] {
        HMparse_html $html {HMrender .help.f.text}
        if {$fragment != ""} {
            HMgoto .help.f.text $fragment
        }
    } else {
        .help.f.text insert end $html
    }      
}

proc HMlink_callback {win href} {
    g_render $href 0
}

proc HMset_image {win handle src} {
    global g_helpDir
    if {![string match /* $src]} {
        set src $g_helpDir/$src
    }
    set name [image create photo -file $src]
    HMgot_image $handle $name
}

proc g_help {url {dir _}} {
    global g_helpHistory g_helpIndex g_helpDir g_docDir g_searchPos g_helpFile
    set g_searchPos 1.0
    if {$dir == "_"} {
        set g_helpDir $g_docDir/interface
    } else {
        set g_helpDir $dir
    }
    set g_helpIndex 0
    set h .help
    g_winPosition $h
    frame $h.f
    scrollbar $h.f.scroll -command "$h.f.text yview" -orient v
    text $h.f.text -width 100 -yscrollcommand "$h.f.scroll set"
	$h.f.text tag configure highlight -foreground black -background yellow
    frame $h.con
    frame $h.con.f2
    entry $h.con.f2.search -textvariable gw_search
    button $h.con.f2.find -text Find -command {g_helpFind 1}
    button $h.con.f2.next -text "Find Next" -command {g_helpFind 0}
    tixButtonBox $h.con.buttons
    $h.con.buttons add copy -text Copy -command g_copy
    if {$url != 0} {
        $h.con.buttons add contents -text Contents -command \
		    {g_render index.htm 0}
    }
    $h.con.buttons add back -text Back -command g_helpBack
    $h.con.buttons add forward -text Forward -command g_helpForward
    $h.con.buttons add close -text Close -command "catch {destroy $h}"
    pack $h.con -fill x
    pack $h.con.f2 -side right
    pack $h.con.buttons -side left
    pack $h.con.f2.search $h.con.f2.find $h.con.f2.next -side left    
    pack $h.f -fill both -expand 1
    pack $h.f.scroll -side right -fill y -expand 0
    pack $h.f.text -side right -fill both -expand 1
    HMinit_win $h.f.text
    if {$url == 0} {
        set g_helpFile ""
        HMparse_html $dir {HMrender .help.f.text}
        set g_helpHistory #_top
        g_render #_top 1
    } else {
        set g_helpHistory $url
        g_render $url 1
    }
    bind $h.con.f2.search <Return> "$h.con.f2.find invoke"
    bind $h <Control-f> {g_helpFind 1}
    bind $h <Control-F> {g_helpFind 1}
    bind $h <Control-n> {g_helpFind 0}
    bind $h <Control-N> {g_helpFind 0}    
}
    
proc g_helpBack {} {
    global g_helpHistory g_helpIndex
    set g_helpIndex [expr $g_helpIndex - 1]
    g_render [lindex $g_helpHistory $g_helpIndex] 1
}

proc g_helpForward {} {
    global g_helpHistory g_helpIndex g_helpTop
    incr g_helpIndex
    g_render [lindex $g_helpHistory $g_helpIndex] 1
}

proc g_helpFind {new} {
    global g_searchPos gw_search
    catch {.help.f.text tag remove highlight 1.0 end}
    set length [string length $gw_search]
    if {$new == 1} {
        set g_searchPos 1.0
    }    
    set result [.help.f.text search -nocase $gw_search $g_searchPos]
    if {$result == ""} {
        bell
    } else {
        .help.f.text see $result
        .help.f.text tag add highlight $result "$result +$length chars"
        set g_searchPos [.help.f.text index "$result +$length chars"]
    }
}
