#
# $Id: objecttags.tcl 3054 1997-11-18 11:41:06Z rgs $
#
# Tk driver <-> TCL interface for altering of graphical objects by clicking with the mouse
# Freddie Akeroyd, ISIS, 26/5/97
#
# On clicking on a object in the PGPLOT window, the procedure g_rightclick_object() will
# be called with the canvas tag and TK widget name. The canvas tag is basically rhe 
# in-memory address of the object and can be assigned to a GCL variable and then GCL
# ALTER commands can be called
#

#
# We are passed object tag and widget name
# The object tag is the address of the OOP - this is supplied by tkdriv.c from pgplot/drivers
#
proc g_select_object { oop_tag W } {

# Create a GCL variable _TCL_TMP that contains the object clicked on
# This will allow us to do things like   gcl { HISTOGRAM/ALTER COLOUR=$RED OBJECT=_TCL_TMP }
    set gcl_object "_TCL_TMP"
# name mangled version of gcl_object
    set smalltalk_object "gXUtclUtmp"	
    smalltalk "Smalltalk at: #$smalltalk_object put: (GraphicalObjects getObjectFromTag: '$oop_tag')!"

# print out the object we have clicked on
#    puts "Clicked on TCL widget $W"
#    puts [ gcl "PRINTN $gcl_object" ]

# create a TCL list containing alternate "inst var name" "value" pairs
    set instvars [ smalltalk "$smalltalk_object getinstvars!" -list ]

# Get the Class Name of the Smalltalk object
    set class [ smalltalk "$smalltalk_object getClassName!" ]
# Remove traling "class" from e.g. "Float class"
    set class [ lindex $class 0 ]		

# get an array indexed by instance variable name e.g. $instarray(colour)
# To change "colour" instance variable use e.g. set instarray(colour) { $RED }
    array set instarray $instvars

# Setting the current open device to the device clicked on
# NEED TO SORT THIS OUT LATER
#    set tmp [string range $W 0 6]
#    set tmp [string trim $tmp .dev]
#    set tmp [string trim $tmp .p]
#    set output [smalltalk "|temp|
#	 temp _ ((gXUUgraphics at: #gXcurrentgraphics) tclSelect: Udevice$tmp).
#	      (temp isNil)
#	     ifFalse:\[gXUUgraphics at: #gXcurrentdevice put: temp\]!"]
#    g_testOutput $output

#
# Call TCL command to bring up the correct dialog box.  
# In general the Smalltalk class "OneDHistogram" will call a TCL method
# called "g_OneDHistogram" with $instarray and $gcl_object as arguments.
# Exceptions, such as Axes/Graticule using the same function, are easily
# programmed if it is advantageous to reuse a piece of code
#
    g_alter $gcl_object $instvars 

#
# This updating code is commented out as, currently, when an object is
# altered, a new instance is created. If the ALTER mechanism were changed 
# to _really_ alter an object, then this may be needed to propagate changes
#
# regenerate instvars list from (modified) instarray
#    set instvars [ array get instarray ]
#
# and update instance variables in the Smalltalk object
#    g_setinstvars $oop_tag $instvars
}

# Called on a right click of a canvas object
# passed object tag (pg + address) and widget name
proc g_rightclick_object { oop_tag W } {
    g_select_object $oop_tag $W
}
