proc OneDErrors {instvars } {
  global colour_options oneDErrors colour_label
  set oneDErrors .alterOneDErrors
  array set instarray $instvars
  catch {destroy $oneDErrors}
  toplevel $oneDErrors
  wm title $oneDErrors "Alter Errors"

  set colour $instarray(colour)
  set thickness $instarray(lineThickness)
  set vertical $instarray(vertical)

  tixOptionMenu $oneDErrors.colour -label "Colour" -variable colour
  foreach opt $colour_options {
    $oneDErrors.colour add command $opt -label $colour_label($opt)
  }

  $oneDErrors.colour config -value $colour

  frame $oneDErrors.top
  pack $oneDErrors.top

  foreach type {horizontal vertical} {
   radiobutton $oneDErrors.top.$type -text $type -variable vertical -value $type
    pack $oneDErrors.top.$type -side left -expand yes -fill x
  }
  if {[string match $vertical vertical] == 0} {
    $oneDErrors.top.vertical select
  } else {
    $oneDErrors.top.horizontal select
  }

  tixLabelEntry $oneDErrors.thickness -label "Line Thickness" -labelside left
  $oneDErrors.thickness subwidget entry config -textvariable thickness

  tixButtonBox $oneDErrors.box -orientation horizontal
  $oneDErrors.box add ok -text Ok -command "drawOneDErrors {$instvars}"
  $oneDErrors.box add cancel -text Cancel -command "catch {destroy $oneDErrors}"

  pack $oneDErrors.colour $oneDErrors.thickness \
       $oneDErrors.box -side top -expand yes -fill x
}

proc drawOneDErrors {instvars} {
  global colour vertical thickness oneDErrors 
  array set instarray $instvars

  set thickness [string trim $thickness]
  if {[string len $thickness] == 0} {
    set thickness $instarray(lineThickness)
  }

  if {[string match $vertical vertical] == 1} {
    set vertical 1
  } else {
    set vertical 0
  }

  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]

  set output [smalltalk "|tmp temp|
	     tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object
		     and: $picture with: '$objectid').
	     (tmp isNil)
	     ifFalse:\[temp _ (tmp colour: $colour; lineThickness: $thickness;
			       vertical: $vertical; create).
		       (gXUUgraphics at: #gXcurrentdevice) Clear.
		((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]
	     ifTrue:\['OneDErrors has not been altered' prinl\] !"]

  testOutput $output
  destroy $oneDErrors
}
