#
# $Id: oneDHistogram.tcl 3023 1997-11-12 13:23:39Z faa $
#
# This is passed a TCL list of instance variable names and values, and 
# also the name of a GCL variable containing the object to be altered
#
proc g_OneDHistogram { gcl_object instvars } {
  global g_colour_options g_colour_label g_line_options g_line_label g_oneDHist
  global g_colour_gcl g_line_gcl
  array set instarray $instvars
  set g_oneDHist .alterOneDHistogram
  catch {destroy $g_oneDHist}
  toplevel $g_oneDHist
  wm title $g_oneDHist "Alter Histogram"

  set g_colour $instarray(colour)
  set g_linetype $instarray(type)
  set g_thickness $instarray(lineThickness)
  set g_centred $instarray(binCentre)

# convert integers into ther symbolic names e.g. $White rather than 1
  set g_colour $g_colour_gcl($g_colour)
  set g_linetype $g_line_gcl($g_linetype)

  tixOptionMenu $g_oneDHist.colour -label "Colour" -variable g_colour
  foreach opt $g_colour_options {
    $g_oneDHist.colour add command $opt -label $g_colour_label($opt)
  }

  tixOptionMenu $g_oneDHist.linetype -label "Line Type" -variable g_linetype
  foreach opt $g_line_options {
    $g_oneDHist.linetype add command $opt -label $g_line_label($opt)
  }

  $g_oneDHist.colour config -value $g_colour
  $g_oneDHist.linetype config -value $g_linetype

  frame $g_oneDHist.top
  pack $g_oneDHist.top

  foreach type {centred notCentred} {
    radiobutton $g_oneDHist.top.$type -text $type -variable g_centred -value $type
    pack $g_oneDHist.top.$type -side left -expand yes -fill x
  }
  $g_oneDHist.top.notCentred select

  tixLabelEntry $g_oneDHist.thickness -label "Line Thickness" -labelside left
  $g_oneDHist.thickness subwidget entry config -textvariable g_thickness

  tixButtonBox $g_oneDHist.box -orientation horizontal
  $g_oneDHist.box add ok -text Ok -command "g_drawOneDHist { $gcl_object { $instvars } }"
  $g_oneDHist.box add cancel -text Cancel -command "catch {destroy $g_oneDHist}"

  pack $g_oneDHist.colour $g_oneDHist.linetype $g_oneDHist.thickness \
       $g_oneDHist.box -side top -expand yes -fill x
}

proc g_drawOneDHist { args } {
  global g_oneDHist
  global g_colour g_centred g_thickness g_linetype
  set args [ lindex $args 0 ]
  set gcl_object [ lindex $args 0 ]
  set instvars [ lindex $args 1 ]
  array set instarray $instvars

  set g_thickness [string trim $g_thickness]
  if {[string len $g_thickness] == 0} {
    set g_thickness $instarray(lineThickness)
  }

  if {[string match $g_centred 1] == 1} {
    set g_centred "/CENTRE"
  } else {
    set g_centred "/NOTCENTRED"
  }
  set output [ gcl "HISTOGRAM/ALTER $g_centred COLOUR=$g_colour LINE_TYPE=$g_linetype LINE_THICKNESS=$g_thickness OBJECT=$gcl_object" ]
  g_testOutput $output
  destroy $g_oneDHist
}
