proc OneDMarkers {instvars} {
  global colour_options colour_label symbol_options symbol_label oneDMark
  set oneDMark .alterOneDMarkers
  array set instarray $instvars
  catch {destroy $oneDMark}
  toplevel $oneDMark
  wm title $oneDMark "Alter Markers"

  set colour $instarray(colour)
  set symbol $instarray(symbol)
  set charsize $instarray(charsize)
  set thickness $instarray(lineThickness)

  tixOptionMenu $oneDMark.colour -label "Colour" -variable colour
  foreach opt $colour_options {
    $oneDMark.colour add command $opt -label $colour_label($opt)
  }

  tixOptionMenu $oneDMark.symbol -label "Marker Symbol" -variable symbol
  foreach opt $symbol_options {
    $oneDMark.symbol add command $opt -label $symbol_label($opt)
  }

  $oneDMark.colour config -value $colour
  $oneDMark.symbol config -value $symbol

  tixLabelEntry $oneDMark.charsize -label "Size" -labelside left
  tixLabelEntry $oneDMark.thickness -label "Symbol Thickness" -labelside left

  $oneDMark.charsize subwidget entry config -textvariable charsize
  $oneDMark.thickness subwidget entry config -textvariable thickness

  tixButtonBox $oneDMark.box -orientation horizontal
  $oneDMark.box add ok -text Ok -command "drawMarkers {$instvars}"
  $oneDMark.box add cancel -text Cancel -command "catch {destroy $oneDMark}"

  pack $oneDMark.colour $oneDMark.symbol $oneDMark.charsize \
       $oneDMark.thickness $oneDMark.box -side top -expand yes -fill x
}

proc drawMarkers {instvars} {
  global thickness symbol colour charsize oneDMark
  array set instarray $instvars
  
  set thickness [string trim $thickness]
  if {[string len $thickness] == 0} {
    set thickness $instarray(lineThickness)
  }

  set charsize [string trim $charsize]
  if {[string len $charsize] == 0} {
    set charsize $instarray(charsize)
  }

  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]

  set output [smalltalk "|tmp temp|
     	     tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object
		     and: $picture with: '$objectid').
	     (tmp isNil)
	     ifFalse:\[temp _ (tmp colour: $colour; symbol: $symbol; 
		 	       lineThickness: $thickness; charsize: $charsize;
			       create).
		       (gXUUgraphics at: #gXcurrentdevice) Clear.
		((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]
	     ifTrue:\['OneDMarkers has not been altered' prinl\] !"]
	   
  testOutput $output
  destroy $oneDMark
}
