proc OneDGraph {instvars} {
  global colour_options colour_label line_options line_label oneDGraph
  set oneDGraph .alterOneDGraph
  array set instarray $instvars
  catch {destroy $oneDGraph}
  toplevel $oneDGraph
  wm title $oneDGraph "Alter Graph"

  set colour $instarray(colour)
  set linetype $instarray(type)
  set thickness $instarray(lineThickness)

  tixOptionMenu $oneDGraph.colour -label "Colour" -variable colour
  foreach opt $colour_options {
    $oneDGraph.colour add command $opt -label $colour_label($opt)
  }

  tixOptionMenu $oneDGraph.linetype -label "Line Type" -variable linetype
  foreach opt $line_options {
    $oneDGraph.linetype add command $opt -label $line_label($opt)
  }

  $oneDGraph.colour config -value $colour
  $oneDGraph.linetype config -value $linetype

  tixLabelEntry $oneDGraph.thickness -label "Line Thickness" -labelside left
  $oneDGraph.thickness subwidget entry config -textvariable thickness

  tixButtonBox $oneDGraph.box -orientation horizontal
  $oneDGraph.box add ok -text Ok -command "drawOneDGraph {$instvars}"
  $oneDGraph.box add cancel -text Cancel -command "catch {destroy $oneDGraph}"

  pack $oneDGraph.colour $oneDGraph.linetype $oneDGraph.thickness \
       $oneDGraph.box -side top -expand yes -fill x
}

proc drawOneDGraph {instvars} {
  global colour thickness oneDGraph linetype
  array set instarray $instvars

  set thickness [string trim $thickness]
  if {[string len $thickness] == 0} {
    set thickness $instarray(lineThickness)
  }

  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]

  set output [smalltalk "|tmp temp|
	     tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object
		     and: $picture with: '$objectid').
	     (tmp isNil)
	     ifFalse:\[temp _ (tmp colour: $colour; lineThickness: $thickness;
			       type: $linetype; create).
		       (gXUUgraphics at: #gXcurrentdevice) Clear.
		((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]
	     ifTrue:\['OneDGraph has not been altered' prinl\] !"]

  testOutput $output
  destroy $oneDGraph
}
