proc picture {} {
  set output [smalltalk "|tmp|
	     tmp _ Picture new.
	     gXUUgraphics at: #gXcurrentpicture put: tmp.
	     ((gXUUgraphics at: #gXcurrentgraphics) addToPictureList: tmp)!"]

testOutput $output
}
 
proc unscaledOptions {} {
  global unscaled colour_options colour_label 
  global unscaled.entries.dxmax
  set unscaled .unscaledOptions
  catch {destroy $unscaled}
  toplevel $unscaled
  wm title $unscaled "Unscaled Window Options"

  frame $unscaled.tle
  pack $unscaled.tle 

  tixLabelEntry $unscaled.tle.dxmin -label DXMin -labelside left
  tixLabelEntry $unscaled.tle.dxmax -label DXMax -labelside left
  tixLabelEntry $unscaled.tle.dymin -label DYMin -labelside left
  tixLabelEntry $unscaled.tle.dymax -label DYMax -labelside left

  $unscaled.tle.dxmin subwidget entry config -textvariable xmin
  $unscaled.tle.dxmax subwidget entry config -textvariable xmax
  $unscaled.tle.dymin subwidget entry config -textvariable ymin
  $unscaled.tle.dymax subwidget entry config -textvariable ymax

  tixOptionMenu $unscaled.colour -label "Window Colour: " -variable colour
  foreach opt $colour_options {
	$unscaled.colour add command $opt -label $colour_label($opt)
  }

  tixButtonBox $unscaled.box -orientation horizontal
  $unscaled.box add ok     -text OK     -command processUnscaled
  $unscaled.box add cancel -text Cancel -command "catch {destroy $unscaled}"

  pack $unscaled.tle.dxmin $unscaled.tle.dxmax $unscaled.tle.dymin \
       $unscaled.tle.dymax $unscaled.colour $unscaled.box -side top \
       -expand yes -fill x
}

proc processUnscaled {} {
  global xmin xmax ymin ymax colour unscaled 
  
  if {[string match *.* $xmax]== 0} {
    set xmax 0.9
  }
  if {[string match *.* $xmin] == 0} {
    set xmin 0.1
  }
  if {[string match *.* $ymax] == 0} {
    set ymax 0.9
  }
  if {[string match *.* $ymin] == 0} {
    set ymin 0.1
  }
  
set output [smalltalk "|tmp a|
	     (gXUUgraphics at: #gXcurrentpicture) isNil
            ifTrue:\['Creating Picture' prinl.
                    tmp _ Picture new.
            	((gXUUgraphics at: #gXcurrentgraphics) addToPictureList: tmp).
              	gXUUgraphics at: #gXcurrentpicture put: tmp\].
             tmp _ (Window new xMin: $xmin; xMax: $xmax; yMin: $ymin;
                             yMax: $ymax; winColour: $colour; create).

   (tmp = nil)
   ifTrue:\['Window has not been created' prenl\]
   ifFalse:\[gXUUgraphics at: #gXcurrentpicture put:
               ((gXUUgraphics at: #gXcurrentpicture) addToList: tmp ).
   gXUUgraphics at: #gXcurrentwindow put: tmp.
   (gXUUgraphics at: #gXcurrentwindow) display\]!"]

  testOutput $output
  destroy $unscaled
}

proc winUnscaled {} {
 set output [ smalltalk "|tmp a|
	     (gXUUgraphics at: #gXcurrentpicture) isNil
            ifTrue:\['Creating Picture' prinl.
                    tmp _ Picture new.
                  ((gXUUgraphics at: #gXcurrentgraphics) addToPictureList: tmp).
                    gXUUgraphics at: #gXcurrentpicture put: tmp\].
             tmp _ (Window new xMin: 0.1; xMax: 0.9; yMin: 0.1; yMax: 0.9;
		    create).

   (tmp = nil)
   ifTrue:\['Window has not been created' prenl\]
   ifFalse:\[gXUUgraphics at: #gXcurrentpicture put:
               ((gXUUgraphics at: #gXcurrentpicture) addToList: tmp ).
   gXUUgraphics at: #gXcurrentwindow put: tmp.
   (gXUUgraphics at: #gXcurrentwindow) display\]!"]

testOutput output
 
} 
