proc Polygon {instvars} {
  global colour_options colour_label polygon
  set polygon .alterpolygon
  array set instarray $instvars
  catch {destroy $polygon}
  toplevel $polygon
  wm title $polygon "Alter Polygon"

  set colour 	$instarray(colour)
  set format 	$instarray(solid)
  set thickness $instarray(lineThickness)

  tixOptionMenu $polygon.colour -label "Colour" -variable colour
  foreach opt $colour_options {
    $polygon.colour add command $opt -label $colour_label($opt)
  }

  $polygon.colour config -value $colour

  tixLabelEntry $polygon.thickness -label "Line Thickness" -labelside left
  
  $polygon.thickness subwidget entry config -textvariable thickness
  
  frame $polygon.top
  pack $polygon.top -side top -expand yes -fill x
  foreach type {solid outline} {
    radiobutton $polygon.top.$type -text $type -variable format -value $type
    pack $polygon.top.$type -side left -expand yes -fill x
  }

  if {[string match $format 1] == 1} {
    $polygon.top.solid select
  } else {
    $polygon.top.outline select
  }

  tixButtonBox $polygon.box -orientation horizontal
  $polygon.box add ok     -text Ok     -command "drawPolygon {$instvars}"
  $polygon.box add cancel -text Cancel -command "catch {destroy $polygon}"

  pack $polygon.colour $polygon.thickness $polygon.box -side top -fill x \
       -expand yes
}

proc drawPolygon {instvars} {
  global polygon colour format thickness
  array set instarray $instvars

  set thickness [string trim $thickness]
  if {[string len $thickness] == 0} {
    set thickness $instarray(lineThickness)
  }

  if {[string match $format solid] == 1} {
    set format 1
  } else {
    set format 0
  }


  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]

  set output [smalltalk "|tmp temp|
             tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object
                     and: $picture with: '$objectid' ).
             (tmp isNil)
             ifFalse:\[temp _ (tmp colour: $colour; solid: $format;
			       lineThickness: $thickness; create).
			(gXUUgraphics at: #gXcurrentdevice) Clear.
		((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]
	     ifTrue:\['Polygon has not been altered' prinl\] !"]

  testOutput $output
  destroy $polygon
}
