proc Polyline {instvars} {
  global colour_options colour_label line line_options line_label
  set line .alterline
  array set instarray $instvars
  catch {destroy $line}
  toplevel $line
  wm title $line "Alter Line" 

  set colour 	$instarray(colour)
  set linetype 	$instarray(type)
  set xstart 	$instarray(xstart)
  set ystart 	$instarray(ystart)
  set xend 	$instarray(xend)
  set yend 	$instarray(yend)
  set thickness $instarray(lineThickness)
 
  tixOptionMenu $line.colour -label "Colour" -variable colour
  foreach opt $colour_options {
    $line.colour add command $opt -label $colour_label($opt)
  }

  tixOptionMenu $line.linetype -label "Line Type" -variable linetype
  foreach opt $line_options {
    $line.linetype add command $opt -label $line_label($opt)
  }

  $line.colour 	 config -value $colour
  $line.linetype config -value $linetype

  tixLabelEntry $line.thickness -label "Line Thickness" -labelside left
  
  $line.thickness subwidget entry config -textvariable thickness

  tixButtonBox $line.box -orientation horizontal
  $line.box add ok     -text OK         -command "drawLine {$instvars} "
  $line.box add cancel -text Cancel     -command "catch {destroy $line}"

  pack $line.colour $line.linetype $line.thickness $line.box -side top \
       -expand yes -fill x

}

proc drawLine {instvars} {
  global colour linetype thickness line
  array set instarray $instvars

  set thickness [string trim $thickness]
  if {[string len $thickness] == 0} {
    set thickness $instarray(lineThickness)
  }

  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]

  set output [smalltalk "|tmp temp|
	     tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object
                     and: $picture with: '$objectid' ).
             (tmp isNil)
             ifFalse:\[temp _ (tmp type: $linetype; lineThickness: $thickness;
			       colour: $colour; create).
			((gXUUgraphics at: #gXcurrentdevice) Clear).
                ((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]
             ifTrue:\['Line has not been altered' prinl\] !"]

  testOutput $output
  destroy $line

}

