proc winScaled {} {
  global scaled
  set scaled .winScaled
  catch {destroy $scaled}
  toplevel $scaled
  wm title $scaled "Scaled Window Options"
  
  frame $scaled.entries
  frame $scaled.labels
  pack $scaled.labels -side left  -padx 0 -pady 0
  pack $scaled.entries -side left -padx 20 -pady 0
  frame $scaled.buttons
  pack $scaled.buttons -side bottom -fill x -pady 2m

  label $scaled.labels.dxmin -text DXMin
  label $scaled.labels.dxmax -text DXMax
  label $scaled.labels.dymin -text DYMin
  label $scaled.labels.dymax -text DYMax
  label $scaled.labels.wxmin -text WXMin
  label $scaled.labels.wxmax -text WXMax
  label $scaled.labels.wymin -text WYMin
  label $scaled.labels.wymax -text WYMax
  label $scaled.labels.colour -text Colour
  label $scaled.labels.minmode -text Minmode
  label $scaled.labels.maxmode -text Maxmode

  entry $scaled.entries.dxmin  -textvariable xmin
  entry $scaled.entries.dxmax  -textvariable xmax
  entry $scaled.entries.dymin  -textvariable ymin
  entry $scaled.entries.dymax  -textvariable ymax 
  entry $scaled.entries.wxmin  -textvariable wxmin
  entry $scaled.entries.wxmax  -textvariable wxmax
  entry $scaled.entries.wymin  -textvariable wymin
  entry $scaled.entries.wymax  -textvariable wymax 
  entry $scaled.entries.colour -textvariable colour
  entry $scaled.entries.minmode -textvariable minmode
  entry $scaled.entries.maxmode -textvariable maxmode

  pack $scaled.labels.dxmin $scaled.entries.dxmin $scaled.labels.dxmax \
       $scaled.entries.dxmax $scaled.labels.dymin $scaled.entries.dymin \
       $scaled.labels.dymax $scaled.entries.dymax $scaled.labels.wxmin \
       $scaled.entries.wxmin $scaled.labels.wxmax $scaled.entries.wxmax \
       $scaled.labels.wymin $scaled.entries.wymin $scaled.labels.wymax \
       $scaled.entries.wymax $scaled.labels.colour $scaled.entries.colour \
       $scaled.labels.minmode $scaled.entries.minmode $scaled.labels.maxmode \
       $scaled.entries.maxmode -side top

  button $scaled.buttons.ok -text OK -command processScaled
  button $scaled.buttons.cancel -text Cancel \
	 -command "catch {destroy $scaled}"

  pack $scaled.buttons.ok $scaled.buttons.cancel -side left -expand 1 
}

proc processScaled {} {
  global xmin xmax ymin ymax wxmin wxmax wymin wymax colour minmode maxmode \
         scaled

  if {[string match *.* $xmax]== 0} {
    set xmax 0.9
  }
  if {[string match *.* $xmin] == 0} {
    set xmin 0.1
  }
  if {[string match *.* $ymax] == 0} {
    set ymax 0.9
  }
  if {[string match *.* $ymin] == 0} {
    set ymin 0.1
  }
  set colour [string trim $colour]
  if {[string len $colour] == 0} {
    set colour 0
  }
  set wxmin [string trim $wxmin]
  if {[string len $wxmin] == 0} {
    set wxmin nil
  }
  set wxmax [string trim $wxmax]
  if {[string len $wxmax] == 0} {
    set wxmax nil
  }
  set wymin [string trim $wymin]
  if {[string len $wymin] == 0} {
    set wymin nil
  }
  set wymax [string trim $wymax]
  if {[string len $wymax] == 0} {
    set wymax nil
  }
  set minmode [string trim $minmode]
  if {[string len $minmode] == 0} {
    set minmode nil
  }
  set maxmode [string trim $maxmode]
  if {[string len $maxmode] == 0} {
    set maxmode nil
  }
  set output [smalltalk "|tmp a|
	     (gXUUgraphics at: #gXcurrentpicture) isNil
            ifTrue:\['Creating Picture' prinl.
                    tmp _ Picture new.
                ((gXUUgraphics at: #gXcurrentgraphics) addToPictureList: tmp).
                gXUUgraphics at: #gXcurrentpicture put: tmp\].
	    tmp _ (WindowScaled new xMin: $xmin; xMax: $xmax; yMin: $ymin;
                   yMax: $ymax; winColour: $colour; minMode: $minmode;
		   maxMode: $maxmode; create).
	    (tmp = nil)
   ifTrue:\['Window has not been created' prenl\]
   ifFalse:\[gXUUgraphics at: #gXcurrentpicture put:
               ((gXUUgraphics at: #gXcurrentpicture) addToList: tmp ).
   gXUUgraphics at: #gXcurrentwindow put: tmp.
   (gXUUgraphics at: #gXcurrentwindow) display\]!"]
  testOutput $output
  destroy  $scaled
}
