proc Text {instvars} {
  global text font_options font_label colour_options colour_label
  set text .textOptions
  catch {destroy $text}
  toplevel $text
  wm title $text "Alter Text"
  array set instarray $instvars
  
  set size $instarray(size)
  set ycoord $instarray(ycoord)
  set xcoord $instarray(xcoord)
  set angle $instarray(angle)

  tixLabelEntry $text.charsize -label "Text Size"    -labelside left
  tixLabelEntry $text.xcoord   -label "X Coordinate" -labelside left
  tixLabelEntry $text.ycoord   -label "Y Coordinate" -labelside left
  tixLabelEntry $text.angle    -label "Angle"   	 -labelside left
  
  $text.charsize subwidget entry config -textvariable size
  $text.xcoord   subwidget entry config -textvariable xcoord
  $text.ycoord   subwidget entry config -textvariable ycoord
  $text.angle    subwidget entry config -textvariable angle

  set colour $instarray(colour)
  set quality $instarray(quality)

  tixOptionMenu $text.quality -label "Text Font" -variable quality
  foreach opt $font_options {
	$text.quality add command $opt -label $font_label($opt)
  }

  tixOptionMenu $text.colour -label "Text Colour" -variable colour
  foreach opt $colour_options {
	$text.colour add command $opt -label $colour_label($opt)
  }

  $text.colour config -value $colour  
  $text.quality config -value $quality  

  tixButtonBox $text.box -orientation horizontal
  $text.box add ok     -text OK     -command "drawText {$instvars}"
  $text.box add cancel -text Cancel -command "destroy $text"

  pack $text.xcoord $text.ycoord $text.charsize $text.angle $text.quality \
       $text.colour $text.box -side top -expand yes -fill x

}

proc drawText {instvars} {
  global colour quality size text xcoord ycoord angle
  array set instarray $instvars

  set size [string trim $size]
  if {[string len $size] == 0} {
    set size $instarray(size)
  }

  set xcoord [string trim $xcoord]
  if {[string len $xcoord] == 0} {
    set xcoord $instarray(xcoord)
  }

  set ycoord [string trim $ycoord]
  if {[string len $ycoord] == 0} {
    set ycoord $instarray(ycoord)
  }

  set angle [string trim $angle]
  if {[string len $angle] == 0} {
    set angle $instarray(angle)
  }

  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]

  set output [smalltalk "|tmp temp|
           tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object
                   and: $picture with: '$objectid').
           (tmp isNil)
           ifFalse:\[temp _ (tmp colour: $colour; xcoord: $xcoord; 
			     ycoord: $ycoord; quality: $quality; 
			     size: $size; angle: $angle; create).
		     (gXUUgraphics at: #gXcurrentdevice) Clear.
		((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]
           ifTrue:\['Object has not been altered' prinl\] !"]

  testOutput $output
  destroy $text
} 
