proc Title {instvars} {
  global title font_options font_label colour_options colour_label
  set title .titleOptions
  catch {destroy $title}
  toplevel $title
  wm title $title "Alter Title"
  array set instarray $instvars
  
  frame $title.tle
  pack $title.tle 

  set text $instarray(title)
  set size $instarray(charsize)

  tixLabelEntry $title.tle.title    -label Title         -labelside left
  tixLabelEntry $title.tle.charsize -label "Text Size"   -labelside left
  
  $title.tle.title    subwidget entry config -textvariable text
  $title.tle.charsize subwidget entry config -textvariable size

  set colour $instarray(colour)
  set quality $instarray(quality)

  tixOptionMenu $title.quality -label "Text Font" -variable quality
  foreach opt $font_options {
	$title.quality add command $opt -label $font_label($opt)
  }

  tixOptionMenu $title.colour -label "Text Colour" -variable colour
  foreach opt $colour_options {
	$title.colour add command $opt -label $colour_label($opt)
  }

  $title.colour config -value $colour  
  $title.quality config -value $quality  

  tixButtonBox $title.box -orientation horizontal
  $title.box add ok     -text OK     -command "drawTitle {$instvars}"
  $title.box add cancel -text Cancel -command "destroy $title"

  pack $title.tle.title $title.tle.charsize $title.quality $title.colour \
       $title.box -side top -expand yes -fill x

}

proc drawTitle {instvars} {
  global text colour quality size title

  array set instarray $instvars

  set size [string trim $size]
  if {[string len $size] == 0} {
    set size $instarray(charsize)
  }

  set text [string trim $text]
  if {[string len $text] == 0} {
    set text $instarray(title)
  }

  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]

  set output [smalltalk "|tmp temp|
	     tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object 
		     and: $picture with: '$objectid').
	     (tmp isNil)
	      ifFalse:\[temp _ (tmp colour: $colour; title: '$text';
				quality: $quality; charsize: $size; create).
			(gXUUgraphics at: #gXcurrentdevice) Clear.
		((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]
	     ifTrue:\['Title has not been altered' prinl\] !"]

  testOutput $output                     
  destroy $title
} 
