C
C $Id: fortran_example.f 5644 2005-04-06 09:43:53Z faa59 $
C
C A program to illustrate calling a module from FORTRAN
C
C Called from GCL with e.g. MODULE:EXECUTE("my_fortran_module", PARS)
C
C Freddie Akeroyd, ISIS, 20/2/97
C
      SUBROUTINE MY_FORTRAN_MODULE(PARS_GET, PARS_PUT)
      IMPLICIT NONE
      REAl VAL1, D(3,2)
      INTEGER I, J, DIMS_ARRAY(2), IADDR(2)
      INTEGER*8 IOFF
      REAL*4 DYNAMIC_ARRAY(1), DARRAY(1)
C
C Include module version information definitions 
C (values of GENIE_MAJOR and GENIE_MINOR)
C
      INCLUDE 'genie_modules.inc'
      EXTERNAL PARS_GET, PARS_PUT
C
C Check we have a recent enough version of the genie library -
C all modules should do this
C
      IF (MODULE_VERSION_OK(GENIE_MAJOR, GENIE_MINOR) .EQ. 0) RETURN
      CALL MODULE_INFORMATION('Executing MY_FORTRAN_MODULE')
C Read some data
      CALL MODULE_GET_REAL(PARS_GET, 'R1', VAL1)

C Write some data
      CALL MODULE_PUT_REAL(PARS_PUT, 'R1', VAL1)
      CALL MODULE_PUT_STRING(PARS_PUT, 'S1', 'Hello there!')
      DO I = 1,2
          DO J = 1,3
              D(J,I) = DBLE(I + J * 10)
          ENDDO
      ENDDO
      DIMS_ARRAY(1) = 3
      DIMS_ARRAY(2) = 2
C Note: FORTRAN stores array column wise, whereas C stores them
C row wise; hence D(3,1) in FORTRAN will become D[1,3] in GCL
      CALL MODULE_PUT_ND_REAL_ARRAY(PARS_PUT, 'ND_ARRAY', 
     1        D, DIMS_ARRAY, 2)
C
C This works on Linux but not Darwin
C
C *** Allocate a dynamic array, fill it up and then return it to GENIE
C      J=500000
C ** Always set IOFF to 0 before calling MODULE_MALLOC
C      IOFF=0
C      CALL MODULE_MALLOC(J, 4, DYNAMIC_ARRAY, IADDR, IOFF)
C      DO I = 1,J
C          DYNAMIC_ARRAY(I+IOFF) = 1.0
C      ENDDO
C      CALL MODULE_PUT_REAL_ARRAY(PARS_PUT, 'RA1', DYNAMIC_ARRAY(1+IOFF),J)
C ** Now map to an existing array
C      CALL MODULE_MAP_REAL_ARRAY(PARS_PUT, 'RA1', DARRAY, J, IOFF)
C      write(6,*) 'mapped to array size ',J
C      do i = 1,min(j,10)
C          write(6,*) darray(i+ioff)
C      enddo
C
      CALL MODULE_INFORMATION('Finished MY_FORTRAN_MODULE')
      RETURN
      END
