#ifndef GENIE_OSTREAM__
#define GENIE_OSTREAM__

// Declare an OMANIP to allow setting of text colours
//      extern std::basic_ostream<_CharT,_Traits>& sc(std::basic_ostream<_CharT,_Traits>& os, int col);
//GENIEIMPORT OMANIP(int) setcolour( int col );

extern void logToFile(const char* file, const char* logval, int options);

#define DOLOGFILE(__value) \
    { \
        if (m_logfile != NULL) \
        { \
            std::ostringstream oss; \
            oss << "ERROR " << (__value) << std::ends; \
            std::string tmpstr = oss.str(); \
            if (m_logfile[0] == '\0') \
            { \
                logToFile(NULL, tmpstr.c_str(), 0x1); \
            } \
            else \
            { \
                logToFile(m_logfile, tmpstr.c_str(), 0x0); \
            } \
        } \
    }

extern std::ostream& sc(std::ostream& os, int col);
struct _Setcolour
{
    int col;
};
inline _Setcolour setcolour(int col)
{
    _Setcolour _sc;
    _sc.col = col;
    return _sc;
}
//    template<typename _CharT, typename _Traits>
//      inline std::basic_ostream<_CharT,_Traits>&
//        operator<<(std::basic_ostream<_CharT,_Traits>& _os, _Setcolour _sc)
//        {
//	   return sc(_os, _sc.col);
//        }
inline std::ostream& operator<<(std::ostream& _os, _Setcolour _sc)
{
    return sc(_os, _sc.col);
}


class genie_ostream : public std::ostream
{

    private:

        int col;				// Records the text colour for the stream
        std::ostringstream  sofar;
        int         logging, screen;	// (Was defined as bool)
        const char* m_logfile;

        // constructors

    public:

        // moved this up two lines from here for Linux & gcc 2.6.3
        //public:
        inline genie_ostream() : logging(0), screen(0), m_logfile(NULL) { }

        // screen_output = 1    -> echo to screen
        GENIEIMPORT genie_ostream(ostream& s, int c = 0, int screen_output = 0, int log = 0, const char* logfile = NULL);

        std::ostringstream* streamBuffer()
        {
            return &sofar;
        }
        // destructor
        inline ~genie_ostream() { }

        // return pointer to characters so far in stringstream, and reset to to start
        GENIEIMPORT std::string str();

        // switch stream on or off, for no parameter, just report current setting
        GENIEIMPORT int screenMode( int imode = 2 )
        {
            if (imode==2) return screen;
            else
            {
                screen = imode;
                return screen;
            }
        }

        GENIEIMPORT genie_ostream &operator=(std::ostream& s);
        GENIEIMPORT genie_ostream &operator=(genie_ostream& s);

        // special flush for logging (if enabled)
        GENIEIMPORT genie_ostream& flush();

        // The member we want to redefine to bracket the output
        // Note: col + 1 is the code for <colour>_OFF (see StreamColour enum in iofuncs.h)
        inline genie_ostream &operator<<(const char *a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(char a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(short a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(int a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(long a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(unsigned char a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(unsigned short a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(unsigned int a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(unsigned long a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        //#ifdef __ultrix
        inline genie_ostream &operator<<(void *a)		// prototype for "const void*" not present
        //#else
        //      inline genie_ostream &operator<<(const void *a)
        //#endif /* __ultrix */
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(std::streambuf *a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(float a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(double a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }
        inline genie_ostream &operator<<(const String& a)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col) << a << setcolour(col+1);
                flush();
            }
            DOLOGFILE(a);
            sofar << a;
            return *this;
        }

        // No point in bracketing the output of IO manips!
        GENIEIMPORT genie_ostream &operator<<(std::ostream &(*a)(std::ostream &));
        GENIEIMPORT genie_ostream &operator<<(std::ios &(*a)(std::ios &));

        // redefine write() to add start and stop sequences
        std::ostream& write(const char *s, size_t n)
        {
            if (screen)
            {
                ((std::ostream&)(*this)) << setcolour(col);
                std::ostream::flush();
                std::ostream::write((const char*)s, n);
                ((std::ostream&)(*this)) << setcolour(col+1);
                std::ostream::flush();
            }
            sofar.write((const char*)s, n);
            return *this;
        }

        /*
           	ostream& write(const unsigned char *s, streamsize n)
              		{ return write((const char*)s, n);}
            	ostream& write(const signed char *s, streamsize n)
              		{ return write((const char*)s, n);}
            	ostream& write(const void *s, streamsize n)
              		{ return write((const char*)s, n);}
        */

};


#endif /* GENIE_OSTREAM__ */
