; F.Akeroyd from original by CMM
	PRO testget

        dims = intarr(2)
        info = ''
	XVALS = fltarr(3000)
	YVALS = dblarr(100)

	debug = 1	; Set to 1 for debugging
	inform = 1	; Set to 1 for informational messages
	i = GI_activate_session('GENIE', inform, debug)

; Bit of general reading/writing of ISIS data, associate a few data items
; with handles ready to access them
	i = GI_select_source('hrp00273.raw')

	i = GI_get('h_HDR',  'HDR',  0)	; Read summary header info
	i = GI_get('h_NSP1', 'NSP1', 0)
	i = GI_get('h_NTC1', 'NTC1', 0)
	i = GI_get('h_DATA', '', 2)		; Read second spectrum

; First get some the data directly into this program
	i = GI_transfer('h_HDR',  '-->' , 'STRING', INFOB,  1, [80L])
	i = GI_transfer('h_NSP1', '-->', 'INT32', SPECS, 0, 0)
	i = GI_transfer('h_NTC1', '-->', 'INT32', NCHAN, 0, 0)
	i = GI_transfer('h_DATA.X', '-->', 'FLOAT32[]', XVALS, 1, [NCHAN])
	NDIMS = 1
	DIMS[0]=100
	i = GI_transfer('h_DATA.Y[200:299]', '-->', 'FLOAT64[]', YVALS, 1, DIMS)

;	Put it back as well and print it out (just as a test)
	NDIMS = 2
	DIMS[0]=50
	DIMS[1]=2
	i = GI_transfer('h_DATA.PUTBACK', '<--', 'FLOAT64[]', YVALS, NDIMS, DIMS)
	i = GI_assign_handle('dummy', 'printin(h_DATA.PUTBACK)')


; And write it out to prove we got it !
	print,'header = ',INFOB
	print,'Spectrum count = ',SPECS
	print,'Time Channels = ',xvals
	print,'Counts = ',yvals
	print,'File header = ',INFO

; Write the data out into several different formats
; note that the 'new' creates a new file, the default is to append
; to an existing file
	i = GI_select_destination('spud.in3', '')
	i = GI_put('h_DATA', 'data', 0, 'new', 'Test data points')
	i = GI_put('h_NSP1', 'nspec', 0, '', 'Number of points')

	i = GI_select_destination('spud.asc', 'ASCII')
	i = GI_put('h_DATA', 'data', 0, 'new', 'Test data points')
	i = GI_put('h_NSP1', 'nspec', 0, '', 'Number of points')

	i = GI_select_destination('spud.nxs', 'NeXus')
	i = GI_put('h_DATA', 'data', 0, 'new', 'Test data points')
	i = GI_put('h_NSP1', 'nspec', 0, '', 'Number of points')

; Now assemble some data into proper NeXus format.  This requires that we
; create entries of the correct NeXus types.
	i = GI_assign_handle('ENTRY1', 'Create("NXentry")')
	i = GI_assign_handle('ENTRY1.DATA', 'Create("NXdata")')
	i = GI_assign_handle('ENTRY1.DATA.X', 'h_DATA.X')
	i = GI_assign_handle('ENTRY1.DATA.Y', 'h_DATA.Y')
	i = GI_assign_handle('ENTRY1.DATA.E', 'h_DATA.E')


; Now append this data to our output files in each format (the NeXus file
; is already the selected destination so does not need re-selecting)
	i = GI_put('ENTRY1', 'entry_1', 0, '', 'Test data points')

	i = GI_select_destination('spud.asc', 'ASCII')
	i = GI_put('ENTRY1', 'entry_1', 0, '', 'Test data points')

	i = GI_select_destination('spud.in3', 'GENIE')
	i = GI_put('ENTRY1', 'entry_1', 0, '', 'Test data points')

; Clear up, delete all the handles and free up memory
	i = GI_deactivate_session()
	
	END
