/* test program to produce density array for gcl program */

#include <stdio.h>
#include <stdlib.h>
#include <genie_cmodule.h>
#include <genie_cmodule_ver.h>

void get_density(GenieWorkspace* pars_get, GenieWorkspace* pars_put)
{
	fort_real d[50][50][50];
	fort_int dims_array[3] = {50,50,50};
	fort_int ndims = 3;
	int c,c2,c3;

	if (!cmodule_version_ok(CMODULE_MAJOR_VERSION, CMODULE_MINOR_VERSION))
	{
		cmodule_print("Library version mismatch for get_density", CMODULE_PRINT_ERROR);
		return;
	}
	cmodule_print("Running get_density", CMODULE_PRINT_INFORMATION);

    for (c=0;c<50;c++)
    {
        for (c2=0;c2<50;c2++)
        {
            for (c3=0;c3<50;c3++)
                d[c][c2][c3]=((c-25)*(c-25))+((c2-25)*(c2-25))+((c3-25)*(c3-25));
        }
    }
    cmodule_put_nd_real_array(pars_put, "dens", (float*)d, dims_array, ndims);       
}
