!
! $Id: genie_modules.f90_in 5123 2002-01-17 15:08:00Z faa $
!
! library/include/genie_modules.f90.  Generated from genie_modules.f90_in by configure.
!
!  F90 version of GENIE_MODULES.INC
!  98/4/1 Ray Osborn
!  98/11/24 Stephan Rosenkranz - simplified interface for user
!		User needs only to specify module_get() and module_put
! What might need to be changed is REAL(Kind=8) to something really portable
! i.e. R8=SELECTED_REAL_KIND(15,127) and REAL(R8)

MODULE Genie_Module
	IMPLICIT NONE

	PUBLIC

! *** Genie version parameters ***
	INTEGER, PARAMETER, PUBLIC :: genie_major = 1
	INTEGER, PARAMETER, PUBLIC :: genie_minor = 2

!   INTEGER, PARAMETER :: R8 = SELECTED_REAL_KIND( 15, 128 )

! *** module functions ***
!   PUBLIC :: module_get_double, module_get_int, module_get_real, module_get_string
!   PUBLIC :: module_get_double_array, module_get_int_array, module_get_real_array
!   PUBLIC :: module_get_string_array 
!   PUBLIC :: module_put_double, module_put_int, module_put_real, module_put_string
!   PUBLIC :: module_put_double_array, module_put_int_array, module_put_real_array 
!   PUBLIC :: module_put_string_array, module_put_nd_real_array


	PUBLIC :: module_version_ok
	PUBLIC :: module_print, module_information, module_error
	PUBLIC :: module_put, module_get

	INTERFACE
		FUNCTION module_version_ok (major, minor) result (status)
			INTEGER, INTENT(in) :: major, minor
			INTEGER :: status
		END FUNCTION module_version_ok
	END INTERFACE

	INTERFACE Module_Get
		SUBROUTINE module_get_double( pars_get, name, value )
			EXTERNAL pars_get
			CHARACTER(len=*), INTENT(in)  :: name
			REAL(KIND=8),     INTENT(out) :: value
		END SUBROUTINE module_get_double

		SUBROUTINE module_get_int( pars_get, name, value )
			EXTERNAL pars_get
			CHARACTER(len=*), INTENT(in)  :: name
			INTEGER,          INTENT(out) :: value
		END SUBROUTINE module_get_int

		SUBROUTINE module_get_real( pars_get, name, value )
			EXTERNAL pars_get
			CHARACTER(len=*), INTENT(in)  :: name
			REAL,             INTENT(out) :: value
		END SUBROUTINE module_get_real

		SUBROUTINE module_get_string( pars_get, name, value )
			EXTERNAL pars_get
			CHARACTER(len=*), INTENT(in)  :: name
			CHARACTER(len=*), INTENT(out) :: value
		END SUBROUTINE module_get_string

		SUBROUTINE module_get_double_array( pars_get, name, value, length )
			EXTERNAL pars_get
			CHARACTER(len=*), INTENT(in)  :: name
			REAL(KIND=8),     INTENT(out) :: value(*)
			INTEGER,          INTENT(out) :: length
		END SUBROUTINE module_get_double_array

		SUBROUTINE module_get_int_array( pars_get, name, value, length )
			EXTERNAL pars_get
			CHARACTER(len=*), INTENT(in)  :: name
			INTEGER,          INTENT(out) :: value(*)
			INTEGER,          INTENT(out) :: length
		END SUBROUTINE module_get_int_array

		SUBROUTINE module_get_real_array( pars_get, name, value, length )
			EXTERNAL pars_get
			CHARACTER(len=*), INTENT(in)  :: name
			REAL,             INTENT(out) :: value(*)
			INTEGER,          INTENT(out) :: length
		END SUBROUTINE module_get_real_array

		SUBROUTINE module_get_string_array( pars_get, name, value, length )
			EXTERNAL pars_get
			CHARACTER(len=*), INTENT(in)  :: name
			CHARACTER(len=*), INTENT(out) :: value(*)
			INTEGER,          INTENT(out) :: length
		END SUBROUTINE module_get_string_array

	END INTERFACE module_get

	INTERFACE Module_Put

		SUBROUTINE module_put_double( pars_put, name, value )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			REAL(KIND=8),     INTENT(in)  :: value
		END SUBROUTINE module_put_double

		SUBROUTINE module_put_int( pars_put, name, value )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			INTEGER,          INTENT(in)  :: value
		END SUBROUTINE module_put_int

		SUBROUTINE module_put_real( pars_put, name, value )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			REAL,             INTENT(in)  :: value
		END SUBROUTINE module_put_real

		SUBROUTINE module_put_string( pars_put, name, value )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			CHARACTER(len=*), INTENT(in)  :: value
		END SUBROUTINE module_put_string

		SUBROUTINE module_put_double_array( pars_put, name, value, length )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			REAL(KIND=8),     INTENT(in)  :: value(*)
			INTEGER,          INTENT(in)  :: length
		END SUBROUTINE module_put_double_array

		SUBROUTINE module_put_int_array( pars_put, name, value, length )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			INTEGER,          INTENT(in)  :: value(*)
			INTEGER,          INTENT(in)  :: length
		END SUBROUTINE module_put_int_array

		SUBROUTINE module_put_real_array( pars_put, name, value, length )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			REAL,             INTENT(in)  :: value(*)
			INTEGER,          INTENT(in)  :: length
		END SUBROUTINE module_put_real_array

		SUBROUTINE module_put_string_array( pars_put, name, value, length )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			CHARACTER(len=*), INTENT(in)  :: value(*)
			INTEGER,          INTENT(in)  :: length
		END SUBROUTINE module_put_string_array

		SUBROUTINE module_put_nd_real_array( pars_put, name, value, dims_array, ndims )
			EXTERNAL pars_put
			CHARACTER(len=*), INTENT(in)  :: name
			REAL,             INTENT(in)  :: value(*)
			INTEGER,          INTENT(in)  :: dims_array(*)
			INTEGER,          INTENT(in)  :: ndims
		END SUBROUTINE module_put_nd_real_array

	END INTERFACE module_put

	INTERFACE
		SUBROUTINE module_print( message )
			CHARACTER(len=*), INTENT(in) :: message
		END SUBROUTINE module_print

		SUBROUTINE module_information( message )
			CHARACTER(len=*), INTENT(in) :: message
		END SUBROUTINE module_information

		SUBROUTINE module_error( function_name, error_message, possible_solution )
			CHARACTER(len=*), INTENT(in) :: function_name, error_message, possible_solution
		END SUBROUTINE module_error
	END INTERFACE

END MODULE genie_module
