C
C *** Module interface to MARI GET_2D_FILE, Freddie Akeroyd, 6/6/96 ***
C
C *** Input workspace fields:
C       FILE                    <String> = Input data source
C
C *** Output Workspace fields:
C
C       X
C       Y
C       S
C       E
C
!MS$ATTRIBUTES DLLEXPORT :: GMODULE_QUERY
	SUBROUTINE GMODULE_QUERY(PARS_GET, PARS_PUT)
	IMPLICIT NONE
        CHARACTER*20 SYMBOL(1),DESCRIP(1),LANGUAGE(1),TYPE(1),EXTENT(1)
	EXTERNAL PARS_GET, PARS_PUT
        INCLUDE 'genie_modules.inc'
C *** check library version
	IF (MODULE_VERSION_OK(GENIE_MAJOR, GENIE_MINOR) .EQ. 0) RETURN
	SYMBOL(1) = 'g_get_2d_file'
	DESCRIP(1) = 'MARI SQE'
	LANGUAGE(1) = 'FORTRAN'
        TYPE(1) = 'INPUT'
        EXTENT(1) = 'sqe'
        CALL MODULE_PUT_STRING_ARRAY(PARS_PUT, 'symbol', symbol, 1)
        CALL MODULE_PUT_STRING_ARRAY(PARS_PUT, 'descrip', descrip, 1)
        CALL MODULE_PUT_STRING_ARRAY(PARS_PUT, 'language', language, 1)
        CALL MODULE_PUT_STRING_ARRAY(PARS_PUT, 'type', type, 1)
        CALL MODULE_PUT_STRING_ARRAY(PARS_PUT, 'extent', extent, 1)
	RETURN
	END

!MS$ATTRIBUTES DLLEXPORT :: G_GET_2D_FILE
	SUBROUTINE g_get_2d_file(pars_get, pars_put)
	IMPLICIT NONE
        INCLUDE 'genie_modules.inc'
	REAL s(201*1001),e(201*1001)
	REAL x(201),y(1001)      
	external pars_get, pars_put
	integer nx, ny
	CHARACTER*80 INPUT_FILE
	integer unit, stat, dims_array(2)
C *** check library version
	IF (MODULE_VERSION_OK(GENIE_MAJOR, GENIE_MINOR) .EQ. 0) RETURN
C
        CALL MODULE_GET_STRING(PARS_GET, 'FILE', INPUT_FILE)
	unit=34
	call module_information('Executing GET_2D_FILE ...')
	open(unit, file=INPUT_FILE, status='OLD', IOSTAT=STAT)
        IF (STAT .NE. 0) THEN
            CALL MODULE_ERROR('GET_2D_FILE', 'Cannot open '//INPUT_FILE,
     1                          'Check file exists and is readable')
            RETURN
        ENDIF
	call get_2d_file (unit, nx, ny, x, y, s, e)
	close(unit,iostat=stat)
C *** we read the array in as (ny,nx), but it will appear as
C *** (nx,ny) in GCL as the array gets flipped 
	dims_array(1) = ny
	dims_array(2) = nx
	call module_put_real_array(pars_put, 'x', x, nx+1)
	call module_put_real_array(pars_put, 'y', y, ny+1)
	call module_put_nd_real_array(pars_put, 's', s, dims_array, 2)
	call module_put_nd_real_array(pars_put, 'e', e, dims_array, 2)
	return
	end
	
cooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
c
c	S.M. Bennington
c	Created:		10 May 1993
c
c	Reads and returns from .SQE format data files

	SUBROUTINE get_2d_file (unit, nx, ny, x, y, s, e)

	REAL s(*),e(*)
	REAL x(*),y(*)      
	INTEGER nx,ny,unit,i,j
	CHARACTER line*225
c
c Read size of the data set
c
	READ(unit,'(2I5)') nx,ny
c
c Read the grids
c
	READ (unit,'(A)') line
	READ (unit, '(8G10.4)') (x(i),i=1,nx+1)
	READ (unit, '(A)') line
	READ (unit, '(8G10.4)') (y(i),i=1,ny+1)     
c
c Read the data
c
	DO i=1,nx
	   READ (unit, '(A)') line
	   READ (unit, '(8G10.4)') (s(j+(i-1)*ny),j=1,ny)
	   READ (unit, '(A)') line
	   READ (unit, '(8G10.4)') (e(j+(i-1)*ny),j=1,ny)
	   DO j = 1,ny
	      e(j+(i-1)*ny) = e(j+(i-1)*ny)**2
	   END DO
	END DO   

	RETURN
	END      
